# Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

# MSC_DEMO.COM	executable program, "Console" variant
# MSC_DEMO.EXE	executable program, "Windows" variant
# MSC_DEMO.DLL
# MSC_DEMO.OBJ	DLL main function object
# MSC_DEMO.CUI	main program object, "Console" variant
# MSC_DEMO.GUI	main program object, "Windows" variant
# MSC_DEMO.LIB	glue data, helper and startup function object library
# MSC_DEMO.LCU	glue data and function object (only for documentation!)
# MSC_DEMO.TMP	DLL startup function object
# MSC_DEMO.CON	program startup function object, "Console" variant
# MSC_DEMO.UNI	program startup function object, "Console" variant, with
#		 command line argument and environment variable support
# MSC_DEMO.WIN	program startup function object, "Windows" variant
# MSC_DEMO.RTC  ???
# MSC_DEMO.RTL	MSC helper functions object
# MSC_DEMO.IMP	MSC helper functions import library, i386 architecture
# MSC_DEMO.INT	MSC helper functions object for 64-bit integers, i386 architecture
# MSC_DEMO.FPU	MSC internal intrinsic object for FPU, i386 architecture
# MSC_DEMO.386	MSC internal intrinsic object, i386 architecture
# MSC_DEMO.AMD	MSC internal intrinsic object, AMD64 architecture
# MSC_DEMO.X86	/GS cookie data and function object, i386 architecture
# MSC_DEMO.X64	/GS cookie data and function object, AMD64 architecture
# MSC_DEMO.TLS	TLS glue data object (only for documentation!)
# MSC_DEMO.AAA	TLS glue data object, AMD64 architecture
# MSC_DEMO.III	TLS glue data object, i386 architecture
# MSC_DEMO.DOS	DOS stub program

all: MSC_DEMO.COM MSC_DEMO.EXE MSC_DEMO.DLL
	MSC_DEMO.EXE
# https://msdn.microsoft.com/en-us/library/a1y7w461.aspx
	MSC_DEMO.COM "a b c" d e
	MSC_DEMO.COM "ab\"c" "\\" d
	MSC_DEMO.COM a\\\b d"e f"g h
	MSC_DEMO.COM a\\\"b c d
	MSC_DEMO.COM a\\\\"b c" d e
	MSC_DEMO.COM a"b"" c d

clean:
	ERASE MSC_DEMO.LIB
	ERASE MSC_DEMO.CUI MSC_DEMO.GUI MSC_DEMO.OBJ
	ERASE MSC_DEMO.FPU MSC_DEMO.INT MSC_DEMO.LCU MSC_DEMO.TLS
	ERASE MSC_DEMO.386 MSC_DEMO.X86 MSC_DEMO.III
	ERASE MSC_DEMO.AMD MSC_DEMO.X64 MSC_DEMO.AAA
	ERASE MSC_DEMO.CON MSC_DEMO.UNI MSC_DEMO.WIN MSC_DEMO.TMP
	ERASE MSC_DEMO.EXP MSC_DEMO.IMP MSC_DEMO.RTL

clobber: clean
	ERASE MSC_DEMO.COM MSC_DEMO.EXE MSC_DEMO.DLL MSC_DEMO.DOS

comment: MSC_DEMO.MAK
	CL.EXE /Brepro /Bt /Bv /GAFS /Gyz /nologo /Tc<< /W4 /X /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

#ident __TIMESTAMP__

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// NOTE: emits (unsupported) linker option /COMMENT:"VOID"

#pragma comment(exestr, "VOID")

#pragma comment(linker, "/ALIGN:4096")
#pragma comment(linker, "/ALLOWBIND")
#pragma comment(linker, "/ALLOWISOLATION")
#pragma comment(linker, "/ALTERNATENAME:@=VOID")	// NOT documented!
#pragma comment(linker, "/APPCONTAINER")
#pragma comment(linker, "/ARM64XFUNCTIONPADMINX64")
#pragma comment(linker, "/ASSEMBLYDEBUG")
#pragma comment(linker, "/ASSEMBLYLINKRESOURCE")
#pragma comment(linker, "/ASSEMBLYMODULE:VOID")
#pragma comment(linker, "/ASSEMBLYRESOURCE")
#pragma comment(linker, "/BASE:65536")
#pragma comment(linker, "/BREPRO")
#pragma comment(linker, "/CETCOMPAT")
#pragma comment(linker, "/CGTHREADS")
#pragma comment(linker, "/CLRIMAGETYPE")
#pragma comment(linker, "/CLRLOADEROPTIMIZATION:NONE")	// NOT documented!
#pragma comment(linker, "/CLRSUPPORTLASTERROR")
#pragma comment(linker, "/CLRTHREADATTRIBUTE:NONE")
#pragma comment(linker, "/CLRUNMANAGEDCODECHECK")
#pragma comment(linker, "/COMMENT:VOID")		// NOT supported any more!
#pragma comment(linker, "/DEBUG")
#pragma comment(linker, "/DEBUGTYPE")
#pragma comment(linker, "/DEF")
#pragma comment(linker, "/DEFAULTLIB:VOID")
#pragma comment(linker, "/DELAY")
#pragma comment(linker, "/DELAYLOAD")
#pragma comment(linker, "/DELAYSIGN")
#pragma comment(linker, "/DEPENDENTLOADFLAG:2048")
#pragma comment(linker, "/DISALLOWLIB:oldnames.lib")	// NOT documented!
#pragma comment(linker, "/DLL")
#pragma comment(linker, "/DLLCHAR")			// NOT documented!
#pragma comment(linker, "/DRIVER")
#pragma comment(linker, "/DYNAMICBASE")
#pragma comment(linker, "/EDITANDCONTINUE")
#pragma comment(linker, "/EMITPOGOPHASEINFO:NO")	// NOT documented!
#pragma comment(linker, "/EMITTOOLVERSIONINFO:NO")	// NOT documented!
#pragma comment(linker, "/ENCPADSIZE")
#pragma comment(linker, "/ENTRY:VOID")
#pragma comment(linker, "/ERRORREPORT")
#pragma comment(linker, "/EXPORT:_VOID")
#pragma comment(linker, "/FASTGENPROFILE")
#pragma comment(linker, "/FE")
#pragma comment(linker, "/FILEALIGN")
#pragma comment(linker, "/FIXED")
#pragma comment(linker, "/FORCE")
#pragma comment(linker, "/FULLBUILD")
#pragma comment(linker, "/FUNCTIONPADMIN")
#pragma comment(linker, "/GENPROFILE")
#pragma comment(linker, "/GUARD")
#pragma comment(linker, "/HEAP:65536,8192")
#pragma comment(linker, "/HDRSIZE")
#pragma comment(linker, "/HIGHENTROPYVA")
#pragma comment(linker, "/IDLOUT")
#pragma comment(linker, "/IGNORE")
#pragma comment(linker, "/IGNOREIDL")
#pragma comment(linker, "/ILK")
#pragma comment(linker, "/IMPLIB")
#pragma comment(linker, "/INCLUDE:_VOID")
#pragma comment(linker, "/INCREMENTAL")
#pragma comment(linker, "/INFERASANLIBS")
#pragma comment(linker, "/INTEGRITYCHECK")
#pragma comment(linker, "/KERNEL")
#pragma comment(linker, "/KEYCONTAINER")
#pragma comment(linker, "/KEYFILE")
#pragma comment(linker, "/LARGEADDRESSAWARE")
#pragma comment(linker, "/LAST:.bss")			// NOT documented!
#pragma comment(linker, "/LIBPATH:VOID")
#pragma comment(linker, "/LINK")
#pragma comment(linker, "/LINKREPRO")
#pragma comment(linker, "/LINKREPROTARGET")
#pragma comment(linker, "/LTCG")
#pragma comment(linker, "/LTCGOUT")
#pragma comment(linker, "/MACHINE")
#pragma comment(linker, "/MANIFEST")
#pragma comment(linker, "/MANIFESTDEPENDENCY:VOID")
#pragma comment(linker, "/MANIFESTFILE")
#pragma comment(linker, "/MANIFESTINPUT")
#pragma comment(linker, "/MANIFESTUAC")
#pragma comment(linker, "/MAP")
#pragma comment(linker, "/MAPINFO")
#pragma comment(linker, "/MERGE:.rdata=.const")
#pragma comment(linker, "/MERGE:.text=.code")
#pragma comment(linker, "/MIDL")
#pragma comment(linker, "/NANE")
#pragma comment(linker, "/NATVIS")
#pragma comment(linker, "/NOASSEMBLY")
#pragma comment(linker, "/NOCOFFGRPINFO")		// NOT documented!
#pragma comment(linker, "/NODEFAULTLIB")
#pragma comment(linker, "/NOENTRY")
#pragma comment(linker, "/NOFUNCTIONPADSECTION")
#pragma comment(linker, "/NOLOGO")
#pragma comment(linker, "/NOOPTIDATA")			// NOT documented!
#pragma comment(linker, "/NXCOMPAT")
#pragma comment(linker, "/OPT")
#pragma comment(linker, "/ORDER")
#pragma comment(linker, "/OSVERSION:0.815")
#pragma comment(linker, "/OUT:VOID")
#pragma comment(linker, "/PAGESIZE")
#pragma comment(linker, "/PCHMAP")
#pragma comment(linker, "/PDB")
#pragma comment(linker, "/PDBALTPATH")
#pragma comment(linker, "/PDBCOMPRESS")
#pragma comment(linker, "/PDBPATH")
#pragma comment(linker, "/PDBSTRIPPED")
#pragma comment(linker, "/PDBTYPE")
#pragma comment(linker, "/PGI")
#pragma comment(linker, "/PGO")
#pragma comment(linker, "/POGOSAFEMODE")
#pragma comment(linker, "/PROFILE")
#pragma comment(linker, "/RE")
#pragma comment(linker, "/RELEASE")
#pragma comment(linker, "/SAFESEH")
#pragma comment(linker, "/SECTION:.bss,d")
#pragma comment(linker, "/SOURCELINK")
#pragma comment(linker, "/SOURCEMAP")
#pragma comment(linker, "/STACK:65536,4096")
#pragma comment(linker, "/STUB")
#pragma comment(linker, "/SUBSYSTEM:CONSOLE")
#pragma comment(linker, "/SWAPRUN:CD,NET")
#pragma comment(linker, "/TEST")			// NOT documented!
#pragma comment(linker, "/TIME")			// NOT documented!
#pragma comment(linker, "/TLBID")
#pragma comment(linker, "/TLBOUT")
#pragma comment(linker, "/TMP")
#pragma comment(linker, "/TSAWARE")
#pragma comment(linker, "/USEPROFILE")
#pragma comment(linker, "/VERBOSE")
#pragma comment(linker, "/VERSION:0.815")
#pragma comment(linker, "/VXD")
#pragma comment(linker, "/WHOLEARCHIVE")
#pragma comment(linker, "/WINMD")
#pragma comment(linker, "/WINMDDELAYSIGN")
#pragma comment(linker, "/WINMDFILE")
#pragma comment(linker, "/WINMDKEYCONTAINER")
#pragma comment(linker, "/WINMDKEYFILE")
#pragma comment(linker, "/WX")
#pragma comment(linker, "/XOFF")

#pragma comment(user, "(C)opyright 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>")

int	VOID(void *module, int reason, void *context)
{
	return context != module, reason;
}
<<NOKEEP

define: MSC_DEMO.MAK
#	CL.EXE /nologo /Tc<< /u /W4 /X /Zl /Zs
	CL.EXE /arch:IA32 /Bt /Bv /J /kernel /MDd /nologo /Tp<< /W4 /X /ZB128 /Zl /Zs
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRING(MACRO)	#MACRO
#define DEFINE(MACRO)	"#define\t" #MACRO STRING(\tMACRO)

// https://msdn.microsoft.com/en-us/library/x7dkzch2.aspx
// https://msdn.microsoft.com/en-us/library/b0084kay.aspx
// https://msdn.microsoft.com/en-us/library/ff540443.aspx

#ifdef __APREFIX
#pragma message(DEFINE(__APREFIX))
#endif
#ifdef __ATOM__
#pragma message(DEFINE(__ATOM__))
#endif
#ifdef __AVX__
#pragma message(DEFINE(__AVX__))
#endif
#ifdef __AVX2__
#pragma message(DEFINE(__AVX2__))
#endif
#ifdef __AVX512BW__
#pragma message(DEFINE(__AVX512BW__))
#endif
#ifdef __AVX512CD__
#pragma message(DEFINE(__AVX512CD__))
#endif
#ifdef __AVX512DQ__
#pragma message(DEFINE(__AVX512DQ__))
#endif
#ifdef __AVX512F__
#pragma message(DEFINE(__AVX512F__))
#endif
#ifdef __AVX512VL__
#pragma message(DEFINE(__AVX512VL__))
#endif
#ifdef __BOOL_DEFINED
#pragma message(DEFINE(__BOOL_DEFINED))
#endif
#ifdef __CLR_VER
#pragma message(DEFINE(__CLR_VER))
#endif
#pragma message(DEFINE(__COUNTER__))
#pragma message(DEFINE(__DATE__))
#pragma message(DEFINE(__FILE__))
#ifdef __FSTREXP
#pragma message(DEFINE(__FSTREXP))
#endif
#ifdef __FUNCDNAME__
#pragma message(DEFINE(__FUNCDNAME__))
#endif
#ifdef __FUNCSIG__
#pragma message(DEFINE(__FUNCSIG__))
#endif
#ifdef __FUNCTION__
#pragma message(DEFINE(__FUNCTION__))
#endif
#ifdef __INTELLISENSE__
#pragma message(DEFINE(__INTELLISENSE__))
#endif
#pragma message(DEFINE(__LINE__))
#ifdef __LPREFIX
#pragma message(DEFINE(__LPREFIX))
#endif
#ifdef __MSVC_RUNTIME_CHECKS
#pragma message(DEFINE(__MSVC_RUNTIME_CHECKS))
#endif
#ifdef __SANITIZE__ADDRESS__
#pragma message(DEFINE(__SANITIZE__ADDRESS__))
#endif
#ifdef __SPREFIX
#pragma message(DEFINE(__SPREFIX))
#endif
#ifdef __STDC__
#pragma message(DEFINE(__STDC__))
#endif
#ifdef __STDC_HOSTED__
#pragma message(DEFINE(__STDC_HOSTED__))
#endif
#ifdef __STDC_NO_ATOMICS__
#pragma message(DEFINE(__STDC_NO_ATOMICS__))
#endif
#ifdef __STDC_NO_COMPLEX__
#pragma message(DEFINE(__STDC_NO_COMPLEX__))
#endif
#ifdef __STDC_NO_THREADS__
#pragma message(DEFINE(__STDC_NO_THREADS__))
#endif
#ifdef __STDC_NO_VLA__
#pragma message(DEFINE(__STDC_NO_VLA__))
#endif
#ifdef __STDC_VERSION__
#pragma message(DEFINE(__STDC_VERSION__))
#endif
#ifdef __STDCPP_THREADS__
#pragma message(DEFINE(__STDCPP_THREADS__))
#endif
#pragma message(DEFINE(__TIME__))
#pragma message(DEFINE(__TIMESTAMP__))
#ifdef __VA_ARGS__
#pragma message(DEFINE(__VA_ARGS__))
#endif
#ifdef __cplusplus
#pragma message(DEFINE(__cplusplus))
#endif
#ifdef __cplusplus_cli
#pragma message(DEFINE(__cplusplus_cli))
#endif
#ifdef __cplusplus_winrt
#pragma message(DEFINE(__cplusplus_winrt))
#endif
#ifdef _CHAR_UNSIGNED
#pragma message(DEFINE(_CHAR_UNSIGNED))
#endif
#ifdef _CONTROL_FLOW_GUARD
#pragma message(DEFINE(_CONTROL_FLOW_GUARD))
#endif
#ifdef _CPPRTTI
#pragma message(DEFINE(_CPPRTTI))
#endif
#ifdef _CPPUNWIND
#pragma message(DEFINE(_CPPUNWIND))
#endif
#ifdef _DEBUG
#pragma message(DEFINE(_DEBUG))
#endif
#ifdef _DLL
#pragma message(DEFINE(_DLL))
#endif
#ifdef _INTEGRAL_MAX_BITS
#pragma message(DEFINE(_INTEGRAL_MAX_BITS))
#endif
#ifdef _ISO_VOLATILE
#pragma message(DEFINE(_ISO_VOLATILE))
#endif
#ifdef _KERNEL_MODE
#pragma message(DEFINE(_KERNEL_MODE))
#endif
#ifdef _M_ALPHA
#pragma message(DEFINE(_M_ALPHA))
#endif
#ifdef _M_AMD64
#pragma message(DEFINE(_M_AMD64))
#endif
#ifdef _M_ARM
#pragma message(DEFINE(_M_ARM))
#endif
#ifdef _M_ARM_ARMV7VE
#pragma message(DEFINE(_M_ARM_ARMV7VE))
#endif
#ifdef _M_ARM_FP
#pragma message(DEFINE(_M_ARM_FP))
#endif
#ifdef _M_ARM64
#pragma message(DEFINE(_M_ARM64))
#endif
#ifdef _M_ARMT
#pragma message(DEFINE(_M_ARMT))
#endif
#ifdef _M_AXP64
#pragma message(DEFINE(_M_AXP64))
#endif
#ifdef _M_CEE
#pragma message(DEFINE(_M_CEE))
#endif
#ifdef _M_CEE_MIXED
#pragma message(DEFINE(_M_CEE_MIXED))
#endif
#ifdef _M_CEE_PURE
#pragma message(DEFINE(_M_CEE_PURE))
#endif
#ifdef _M_CEE_SAFE
#pragma message(DEFINE(_M_CEE_SAFE))
#endif
#ifdef _M_FP_CONTRACT
#pragma message(DEFINE(_M_FP_CONTRACT))
#endif
#ifdef _M_FP_EXCEPT
#pragma message(DEFINE(_M_FP_EXCEPT))
#endif
#ifdef _M_FP_FAST
#pragma message(DEFINE(_M_FP_FAST))
#endif
#ifdef _M_FP_PRECISE
#pragma message(DEFINE(_M_FP_PRECISE))
#endif
#ifdef _M_FP_STRICT
#pragma message(DEFINE(_M_FP_STRICT))
#endif
#ifdef _M_HYBRID
#pragma message(DEFINE(_M_HYBRID))
#endif
#ifdef _M_HYBRID_X86_ARM64
#pragma message(DEFINE(_M_HYBRID_X86_ARM64))
#endif
#ifdef _M_I86
#pragma message(DEFINE(_M_I86))
#endif
#ifdef _M_IA64
#pragma message(DEFINE(_M_IA64))
#endif
#ifdef _M_IX86
#pragma message(DEFINE(_M_IX86))
#endif
#ifdef _M_IX86_FP
#pragma message(DEFINE(_M_IX86_FP))
#endif
#ifdef _M_M68K
#pragma message(DEFINE(_M_M68K))
#endif
#ifdef _M_MPPC
#pragma message(DEFINE(_M_MPPC))
#endif
#ifdef _M_MRX000
#pragma message(DEFINE(_M_MRX000))
#endif
#ifdef _M_PPC
#pragma message(DEFINE(_M_PPC))
#endif
#ifdef _M_X64
#pragma message(DEFINE(_M_X64))
#endif
#ifdef _MANAGED
#pragma message(DEFINE(_MANAGED))
#endif
#pragma message(DEFINE(_MSC_BUILD))
#pragma message(DEFINE(_MSC_EXTENSIONS))
#pragma message(DEFINE(_MSC_FULL_VER))
#pragma message(DEFINE(_MSC_VER))
#ifdef _MSVC_LANG
#pragma message(DEFINE(_MSVC_LANG))
#endif
#ifdef _MSVC_TRADITIONAL
#pragma message(DEFINE(_MSVC_TRADITIONAL))
#endif
#ifdef _MT
#pragma message(DEFINE(_MT))
#endif
#ifdef _NATIVE_NULLPTR_SUPPORTED
#pragma message(DEFINE(_NATIVE_NULLPTR_SUPPORTED))
#endif
#ifdef _NATIVE_WCHAR_T_DEFINED
#pragma message(DEFINE(_NATIVE_WCHAR_T_DEFINED))
#endif
#ifdef _OPENMP
#pragma message(DEFINE(_OPENMP))
#endif
#ifdef _PREFAST
#pragma message(DEFINE(_PREFAST))
#endif
#ifdef _RVALUE_REFERENCES_SUPPORTED
#pragma message(DEFINE(_RVALUE_REFERENCES_SUPPORTED))
#endif
#ifdef _RVALUE_REFERENCES_V2_SUPPORTED
#pragma message(DEFINE(_RVALUE_REFERENCES_V2_SUPPORTED))
#endif
#ifdef _VC_NODEFAULTLIB
#pragma message(DEFINE(_VC_NODEFAULTLIB))
#endif
#ifdef _WCHAR_T_DEFINED
#pragma message(DEFINE(_WCHAR_T_DEFINED))
#endif
#ifdef _WIN32
#pragma message(DEFINE(_WIN32))
#endif
#ifdef _WIN64
#pragma message(DEFINE(_WIN64))
#endif
#ifdef _WINRT_DLL
#pragma message(DEFINE(_WINRT_DLL))
#endif
<<NOKEEP

intrinsic: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /Bv /c /FoNUL: /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /X /Zc:wchar_t /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx
// https://msdn.microsoft.com/en-us/library/5704bbxw.aspx

typedef	unsigned char	char_t;
#ifndef _WIN64
typedef	unsigned int	size_t;
#endif
#ifndef _NATIVE_WCHAR_T_DEFINED		// NOTE: C++ only!
typedef	unsigned short	wchar_t;
#else
wchar_t	date[] = __LPREFIX(__DATE__);
#endif
#ifdef _WCHAR_T_DEFINED
wchar_t	time[] = __LPREFIX(__TIME__);
#endif

// https://msdn.microsoft.com/en-us/library/zyaebf12.aspx
// https://msdn.microsoft.com/en-us/library/d7zdhf37.aspx
// https://msdn.microsoft.com/en-us/library/dswaw1wk.aspx
// https://msdn.microsoft.com/en-us/library/8k35d1fx.aspx
// https://msdn.microsoft.com/en-us/library/1fdeehz6.aspx

int	memcmp(void const *source, void const *destination, size_t count);
void	*memchr(void const *memory, char cb, size_t count);
void	*memcpy(void *destination, void const *source, size_t count);
void	*memmove(void *destination, void const *source, size_t count);
void	*memrchr(void const *memory, char cb, size_t count);
void	*memset(void *destination, char cb, size_t count);

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(memcmp, memchr, memcpy, memmove, memrchr, memset)

// https://msdn.microsoft.com/en-us/library/zyaebf12.aspx
// https://msdn.microsoft.com/en-us/library/d7zdhf37.aspx
// https://msdn.microsoft.com/en-us/library/dswaw1wk.aspx
// https://msdn.microsoft.com/en-us/library/8k35d1fx.aspx
// https://msdn.microsoft.com/en-us/library/1fdeehz6.aspx

int	wmemcmp(wchar_t const *source, wchar_t const *destination, size_t count);
wchar_t	*wmemchr(wchar_t const *memory, wchar_t cw, size_t count);
wchar_t	*wmemcpy(wchar_t *destination, wchar_t const *source, size_t count);
wchar_t	*wmemmove(wchar_t *destination, wchar_t const *source, size_t count);
wchar_t	*wmemrchr(wchar_t const *memory, wchar_t cw, size_t count);
wchar_t	*wmemset(wchar_t *destination, wchar_t cw, size_t count);

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(wmemcmp, wmemchr, wmemcpy, wmemmove, wmemrchr, wmemset)

// https://msdn.microsoft.com/en-us/library/h1x0y282.aspx
// https://msdn.microsoft.com/en-us/library/b34ccac3.aspx
// https://msdn.microsoft.com/en-us/library/e0z9k731.aspx
// https://msdn.microsoft.com/en-us/library/a7cwbx4t.aspx
// https://msdn.microsoft.com/en-us/library/kk6xf663.aspx
// https://msdn.microsoft.com/en-us/library/xe8sk0x7.aspx
// https://msdn.microsoft.com/en-us/library/78zh94ax.aspx
// https://msdn.microsoft.com/en-us/library/tbyd7s1y.aspx
// https://msdn.microsoft.com/en-us/library/eywx8zcx.aspx
// https://msdn.microsoft.com/en-us/library/xdsywd25.aspx
// https://msdn.microsoft.com/en-us/library/ms235495.aspx
// https://msdn.microsoft.com/en-us/library/217yyhy9.aspx
// https://msdn.microsoft.com/en-us/library/ftw0heb9.aspx
// https://msdn.microsoft.com/en-us/library/ms235404.aspx
// https://msdn.microsoft.com/en-us/library/ms235359.aspx
// https://msdn.microsoft.com/en-us/library/kthzzay9.aspx
// https://msdn.microsoft.com/en-us/library/z9da80kz.aspx
// https://msdn.microsoft.com/en-us/library/2c8d19sb.aspx
// https://msdn.microsoft.com/en-us/library/373xd2sx.aspx

char	*strcat(char *destination, char const *source);
char	*strchr(char const *string, char cb);
int	strcmp(char const *source, char const *destination);
int	strcoll(char const *source, char const *destination);
char	*strcpy(char *destination, char const *source);
size_t	strcspn(char const *string, char const *set);
int	stricmp(char const *source, char const *destination);
size_t	strlen(char const *string);
char	*strncat(char *destination, char const *source, size_t count);
int	strncmp(char const *source, char const *destination, size_t count);
char	*strncpy(char *destination, char const *source, size_t count);
size_t	strnlen(char const *string, size_t count);
char	*strnset(char *string, char cb, size_t count);
char	*strpbrk(char const *string, char const *set);
char	*strrchr(char const *string, char cb);
char	*strrev(char *string);
char	*strset(char *string, char cb);
size_t	strspn(char const *string, char const *set);
char	*strstr(char const *string, char const *substring);
char	*strtok(char *string, char const *delimiter);
int	_stricmp(char const *source, char const *destination);
char	*_strnset(char *string, char cb, size_t count);
char	*_strset(char *string, char cb);

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(strcat, strchr, strcmp, strcoll, strcpy, strcspn, stricmp, strlen, strncat, strncmp, strncpy, strnlen, strnset, strpbrk, strrchr, strrev, strset, strspn, strstr, strtok, _stricmp, _strnset, _strset)

// https://msdn.microsoft.com/en-us/library/h1x0y282.aspx
// https://msdn.microsoft.com/en-us/library/b34ccac3.aspx
// https://msdn.microsoft.com/en-us/library/e0z9k731.aspx
// https://msdn.microsoft.com/en-us/library/a7cwbx4t.aspx
// https://msdn.microsoft.com/en-us/library/kk6xf663.aspx
// https://msdn.microsoft.com/en-us/library/xe8sk0x7.aspx
// https://msdn.microsoft.com/en-us/library/78zh94ax.aspx
// https://msdn.microsoft.com/en-us/library/tbyd7s1y.aspx
// https://msdn.microsoft.com/en-us/library/eywx8zcx.aspx
// https://msdn.microsoft.com/en-us/library/xdsywd25.aspx
// https://msdn.microsoft.com/en-us/library/ms235495.aspx
// https://msdn.microsoft.com/en-us/library/217yyhy9.aspx
// https://msdn.microsoft.com/en-us/library/ftw0heb9.aspx
// https://msdn.microsoft.com/en-us/library/ms235404.aspx
// https://msdn.microsoft.com/en-us/library/ms235359.aspx
// https://msdn.microsoft.com/en-us/library/kthzzay9.aspx
// https://msdn.microsoft.com/en-us/library/z9da80kz.aspx
// https://msdn.microsoft.com/en-us/library/2c8d19sb.aspx
// https://msdn.microsoft.com/en-us/library/373xd2sx.aspx

wchar_t	*wcscat(wchar_t *destination, wchar_t const *source);
wchar_t	*wcschr(wchar_t const *string, wchar_t cw);
int	wcscmp(wchar_t const *source, wchar_t const *destination);
int	wcscoll(wchar_t const *source, wchar_t const *destination);
wchar_t	*wcscpy(wchar_t *destination, wchar_t const *source);
size_t	wcscspn(wchar_t const *string, wchar_t const *set);
int	wcsicmp(wchar_t const *source, wchar_t const *destination);
size_t	wcslen(wchar_t const *string);
wchar_t	*wcsncat(wchar_t *destination, wchar_t const *source, size_t count);
int	wcsncmp(wchar_t const *source, wchar_t const *destination, size_t count);
wchar_t	*wcsncpy(wchar_t *destination, wchar_t const *source, size_t count);
size_t	wcsnlen(wchar_t const *string, size_t count);
wchar_t	*wcsnset(wchar_t *string, wchar_t cw, size_t count);
wchar_t	*wcspbrk(wchar_t const *string, wchar_t const *set);
wchar_t	*wcsrchr(wchar_t const *string, wchar_t cw);
wchar_t	*wcsrev(wchar_t *string);
wchar_t	*wcsset(wchar_t *string, wchar_t cw);
size_t	wcsspn(wchar_t const *string, wchar_t const *set);
wchar_t	*wcsstr(wchar_t const *string, wchar_t const *substring);
wchar_t	*wcstok(wchar_t *string, wchar_t const *delimiter);
int	_wcsicmp(wchar_t const *source, wchar_t const *destination);
wchar_t	*_wcsnset(wchar_t *string, wchar_t cw, size_t count);
wchar_t	*_wcsset(wchar_t *string, wchar_t cw);

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(wcscat, wcschr, wcscmp, wcscoll, wcscpy, wcscspn, wcsicmp, wcslen, wcsncat, wcsncmp, wcsncpy, wcsnlen, wcsnset, wcspbrk, wcsrchr, wcsrev, wcsset, wcsspn, wcsstr, wcstok, _wcsicmp, _wcsnset, _wcsset)

// https://msdn.microsoft.com/en-us/library/hhta9830.aspx
// https://msdn.microsoft.com/en-us/library/adf7db3x.aspx
// https://msdn.microsoft.com/en-us/library/9d196b9h.aspx
// https://msdn.microsoft.com/en-us/library/4tt6fykh.aspx

void	__movsb(unsigned      char *destination, unsigned      char const *source, size_t count);
void	__movsw(unsigned     short *destination, unsigned     short const *source, size_t count);
void	__movsd(unsigned      long *destination, unsigned      long const *source, size_t count);
void	__movsq(unsigned long long *destination, unsigned long long const *source, size_t count);

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(__movsb, __movsw, __movsd, __movsq)

// https://msdn.microsoft.com/en-us/library/ywwcatsa.aspx
// https://msdn.microsoft.com/en-us/library/k99wy47b.aspx
// https://msdn.microsoft.com/en-us/library/d72sd2b6.aspx
// https://msdn.microsoft.com/en-us/library/3dsh30sa.aspx

void	__stosb(unsigned      char *destination, unsigned      char cb, size_t count);
void	__stosw(unsigned     short *destination, unsigned     short cw, size_t count);
void	__stosd(unsigned      long *destination, unsigned      long cd, size_t count);
void	__stosq(unsigned long long *destination, unsigned long long cq, size_t count);

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(__stosb, __stosw, __stosd, __stosq)

// https://msdn.microsoft.com/en-us/library/bztkwykh.aspx
// https://msdn.microsoft.com/en-us/library/dn465171.aspx
// https://msdn.microsoft.com/en-us/library/txk32e70.aspx
// https://msdn.microsoft.com/en-us/library/dn465168.aspx
// https://msdn.microsoft.com/en-us/library/88c36t42.aspx
// https://msdn.microsoft.com/en-us/library/dn324930.aspx
// https://msdn.microsoft.com/en-us/library/atdhw2dx.aspx
// https://msdn.microsoft.com/en-us/library/0yafk1hc.aspx
// https://msdn.microsoft.com/en-us/library/ydcbat90.aspx
// https://msdn.microsoft.com/en-us/library/c850xxez.aspx
// https://msdn.microsoft.com/en-us/library/mt720713.aspx
// https://msdn.microsoft.com/en-us/library/dn353645.aspx
// https://msdn.microsoft.com/en-us/library/18z15bk0.aspx
// https://msdn.microsoft.com/en-us/library/mt720714.aspx
// https://msdn.microsoft.com/en-us/library/x39715t6.aspx
// https://msdn.microsoft.com/en-us/library/mt720717.aspx
// https://msdn.microsoft.com/en-us/library/mt720716.aspx
// https://msdn.microsoft.com/en-us/library/20dckbeh.aspx
// https://msdn.microsoft.com/en-us/library/w1xfschh.aspx
// https://msdn.microsoft.com/en-us/library/a9yb3dbt.aspx
// https://msdn.microsoft.com/en-us/library/mt720719.aspx
// https://msdn.microsoft.com/en-us/library/zx52ds7f.aspx
// https://msdn.microsoft.com/en-us/library/t63833dz.aspx
// https://msdn.microsoft.com/en-us/library/mt720722.aspx
// https://msdn.microsoft.com/en-us/library/mt720721.aspx
// https://msdn.microsoft.com/en-us/library/t63833dz.aspx
// https://msdn.microsoft.com/en-us/library/e4x82d9s.aspx
// https://msdn.microsoft.com/en-us/library/mt720723.aspx
// https://msdn.microsoft.com/en-us/library/bk4c380c.aspx
// https://msdn.microsoft.com/en-us/library/dt5dakze.aspx
// https://msdn.microsoft.com/en-us/library/dn465170.aspx
// https://msdn.microsoft.com/en-us/library/dn465175.aspx
// https://msdn.microsoft.com/en-us/library/dn465165.aspx
// https://msdn.microsoft.com/en-us/library/dn353646.aspx
// https://msdn.microsoft.com/en-us/library/dn465179.aspx
// https://msdn.microsoft.com/en-us/library/wkbss70y.aspx
// https://msdn.microsoft.com/en-us/library/f1xa99e6.aspx
// https://msdn.microsoft.com/en-us/library/twws9xxw.aspx
// https://msdn.microsoft.com/en-us/library/mt720727.aspx
// https://msdn.microsoft.com/en-us/library/esw6b4yx.aspx

double	acos(double argument);
double	acosh(double argument);
double	acot(double argument);
double	acot2(double argument);
double	acoth(double argument);
double	asin(double argument);
double	asinh(double argument);
double	atan(double argument);
double	atan2(double dividend, double divisor);
double	atanh(double argument);
double	ceil(double argument);
double	copysign(double magnitude, double sign);
double	cos(double argument);
double	cosh(double argument);
double	cot(double argument);
double	coth(double argument);
double	exp(double exponent);
double	exp2(double exponent);
double	exp10(double exponent);
double	expm1(double exponent);
double	fabs(double argument);
double	fdim(double m, double n);
double	floor(double argument);
double	fmax(double m, double n);
double	fmin(double m, double n);
double	fmod(double dividend, double divisor);
double	frexp(double argument, int *exponent);
double	hypot(double m, double n);
int	ilogb(double argument);
double	ldexp(double argument, int exponent);
double	log(double argument);
double	log1p(double argument);
double	log2(double argument);
double	log10(double argument);
double	logb(double argument);
int	lrint(double argument);
long long	llrint(double argument);
double	modf(double argument, double *integer);
double	pow(double base, double exponent);
double	remainder(double dividend, double divisor);
double	remquo(double dividend, double divisor, int *quotient);
double	rint(double argument);
double	round(double argument);
double	scalbn(double argument, int exponent);
double	sin(double argument);
double	sinh(double argument);
double	sqrt(double radicand);
double	tan(double argument);
double	tanh(double argument);
double	trunc(double argument);
double	_scalb(double argument, int exponent);

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(acos, acosh, acot, acot2, acoth, asin, asinh, atan, atan2, atanh, ceil, copysign, cos, cosh, cot, coth, exp, exp2, exp10, exp1m, fabs, fdim, floor, fmax, fmin, fmod, frexp, hypot, ilogb, ldexp, log, log1p, log2, log10, logb, lrint, llrint, modf, pow, remainder, remquo, rint, round, scalbn, sin, sinh, sqrt, tan, tanh, trunc, _scalb)

// https://msdn.microsoft.com/en-us/library/3ze4ytsc.aspx
// https://msdn.microsoft.com/en-us/library/6wd819wh.aspx
// https://msdn.microsoft.com/en-us/library/bky3b5dh.aspx

int	main(int argc, char *argv[], char *envp[])
{
// https://msdn.microsoft.com/en-us/library/x7dkzch2.aspx

#pragma message("__FUNCDNAME__ = " __FUNCDNAME__)
#pragma message("__FUNCSIG__   = " __FUNCSIG__)
#pragma message("__FUNCTION__  = " __FUNCTION__)

	return envp != argv[argc];

	__annotation(__LPREFIX(__FUNCDNAME__), __LPREFIX(__FUNCSIG__), __LPREFIX(__FUNCTION__));

	// https://msdn.microsoft.com/en-us/library/1b3fsfxw.aspx

	__assume(0);
}

int	wmain(int argc, wchar_t *argv[], wchar_t *envp[])
{
// https://msdn.microsoft.com/en-us/library/x7dkzch2.aspx

#pragma message("__FUNCDNAME__ = " __FUNCDNAME__)
#pragma message("__FUNCSIG__   = " __FUNCSIG__)
#pragma message("__FUNCTION__  = " __FUNCTION__)

	return envp != argv[argc];

	__annotation(__LPREFIX(__FUNCDNAME__), __LPREFIX(__FUNCSIG__), __LPREFIX(__FUNCTION__));

	// https://msdn.microsoft.com/en-us/library/1b3fsfxw.aspx

	__assume(0);
}

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

void	mainCRTStartup(void)
{
// https://msdn.microsoft.com/en-us/library/x7dkzch2.aspx

#pragma message("__FUNCDNAME__ = " __FUNCDNAME__)
#pragma message("__FUNCSIG__   = " __FUNCSIG__)
#pragma message("__FUNCTION__  = " __FUNCTION__)
}
<<NOKEEP

MSC_DEMO.COM: MSC_DEMO.CUI MSC_DEMO.LIB MSC_DEMO.DOS # KERNEL32.LIB
	LINK.EXE /LINK /BREPRO /DYNAMICBASE /LARGEADDRESSAWARE /MERGE:.edata=.export /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NODEFAULTLIB /NOLOGO /NOOPTIDATA /NXCOMPAT /OPT:ICF,REF /OUT:$@ /RELEASE /SECTION:.bss,d /STUB:MSC_DEMO.DOS /TEST /VERSION:0.815 MSC_DEMO.CUI MSC_DEMO.LIB KERNEL32.LIB
	LINK.EXE /EDIT /NOLOGO /SECTION:.bss,!d /SECTION:.idata=.import $@

MSC_DEMO.EXE: MSC_DEMO.GUI MSC_DEMO.LIB MSC_DEMO.DOS # KERNEL32.LIB
	LINK.EXE /LINK /BREPRO /DYNAMICBASE /LARGEADDRESSAWARE /MERGE:.edata=.export /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NODEFAULTLIB /NOLOGO /NOOPTIDATA /NXCOMPAT /OPT:ICF,REF /OUT:$@ /RELEASE /SECTION:.bss,d /STUB:MSC_DEMO.DOS /TEST /VERSION:0.815 MSC_DEMO.GUI MSC_DEMO.LIB KERNEL32.LIB
	LINK.EXE /EDIT /NOLOGO /SECTION:.bss,!d /SECTION:.idata=.import $@

MSC_DEMO.DLL: MSC_DEMO.OBJ MSC_DEMO.LIB MSC_DEMO.DOS # KERNEL32.LIB
	LINK.EXE /LINK /BREPRO /DLL /DYNAMICBASE /LARGEADDRESSAWARE /MERGE:.edata=.export /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NODEFAULTLIB /NOLOGO /NOOPTIDATA /NXCOMPAT /OPT:ICF,REF /OUT:$@ /RELEASE /SECTION:.bss,d /STUB:MSC_DEMO.DOS /TEST /VERSION:0.815 MSC_DEMO.OBJ MSC_DEMO.LIB KERNEL32.LIB
	LINK.EXE /EDIT /NOLOGO /SECTION:.bss,!d /SECTION:.idata=.import $@

MSC_DEMO.OBJ: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /wd4100 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".program")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ms682583.aspx
// https://msdn.microsoft.com/en-us/library/ms682596.aspx

BOOL	WINAPI	DllMain(HANDLE hModule,
		        DWORD  dwReason,
		        LPVOID lpReserved)
{
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	return dwReason == DLL_PROCESS_ATTACH;
}
<<NOKEEP

MSC_DEMO.CUI: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /DUNICODE /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".program")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#ifdef UNICODE
typedef	unsigned short	wchar_t;

int	wmain(int argc, wchar_t *argv[], wchar_t *envp[])
#else
int	main(int argc, char *argv[], char *envp[])
#endif // UNICODE
{
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	return envp != argv[argc];
}
<<NOKEEP

MSC_DEMO.GUI: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /DUNICODE /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".program")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ms633559.aspx

#ifdef UNICODE
INT	WINAPI	wWinMain(HINSTANCE hInstance,
		         HINSTANCE hPrevInstance,
	                 LPWSTR    lpCmdLine,
	                 INT       nCmdShow)
#else
INT	WINAPI	WinMain(HINSTANCE hInstance,
		        HINSTANCE hPrevInstance,
	                LPSTR     lpCmdLine,
	                INT       nCmdShow)
#endif // UNICODE
{
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	return lpCmdLine[hInstance == hProvInstance] != nCmdShow;
}
<<NOKEEP

-MSC_DEMO.LIB: MSC_DEMO.TMP MSC_DEMO.CON MSC_DEMO.UNI MSC_DEMO.WIN MSC_DEMO.RTL MSC_DEMO.IMP MSC_DEMO.AMD MSC_DEMO.X64 MSC_DEMO.AAA
	LINK.EXE /LIB /BREPRO /MACHINE:AMD64 /NODEFAULTLIB /NOLOGO /OUT:$@ $**

-MSC_DEMO.IMP: MSC_DEMO.MAK
# https://msdn.microsoft.com/en-us/library/mt732293.aspx
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:__C_specific_handler /MACHINE:AMD64 /NAME:KERNEL32 /NODEFAULTLIB /NOLOGO /OUT:$@

MSC_DEMO.LIB: MSC_DEMO.TMP MSC_DEMO.CON MSC_DEMO.UNI MSC_DEMO.WIN MSC_DEMO.RTL MSC_DEMO.FPU MSC_DEMO.INT MSC_DEMO.386 MSC_DEMO.X86 MSC_DEMO.III # MSC_DEMO.IMP
	LINK.EXE /LIB /BREPRO /MACHINE:I386 /NODEFAULTLIB /NOLOGO /OUT:$@ $**

MSC_DEMO.IMP: MSC_DEMO.MAK
# https://msdn.microsoft.com/en-us/library/dn727675.aspx
# https://msdn.microsoft.com/en-us/library/ms648425.aspx
# https://msdn.microsoft.com/en-us/library/mt703294.aspx
# https://msdn.microsoft.com/en-us/library/ff770589.aspx
# https://msdn.microsoft.com/en-us/library/ff770580.aspx
# https://msdn.microsoft.com/en-us/library/ff770583.aspx
# https://msdn.microsoft.com/en-us/library/ff770597.aspx
# https://msdn.microsoft.com/en-us/library/ff770588.aspx
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:_alldiv /EXPORT:_alldvrm /EXPORT:_allmul /EXPORT:_alloca_probe /EXPORT:_alloca_probe_8 /EXPORT:_alloca_probe_16 /EXPORT:_allrem /EXPORT:_allshl /EXPORT:_allshr /EXPORT:_aulldiv /EXPORT:_aulldvrm /EXPORT:_aullrem /EXPORT:_aullshr /EXPORT:_chkstk /EXPORT:_CIcos /EXPORT:_CIlog /EXPORT:_CIpow /EXPORT:_CIsin /EXPORT:_CIsqrt /EXPORT:_fltused /EXPORT:_ftol /EXPORT:memchr /EXPORT:memcmp /EXPORT:memcpy /EXPORT:memmove /EXPORT:memset /MACHINE:I386 /NAME:NTDLL /NODEFAULTLIB /NOLOGO /OUT:$@

MSC_DEMO.TMP: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /DGSCOOKIE /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".startup")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ms682583.aspx
// https://msdn.microsoft.com/en-us/library/ms682596.aspx

extern	BOOL	WINAPI	DllMain(HANDLE hModule,
			        DWORD  dwReason,
			        LPVOID lpReserved);

// https://msdn.microsoft.com/en-us/library/988ye33t.aspx
// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule,
		                   DWORD  dwReason,
		                   LPVOID lpReserved)
{
#ifdef GSCOOKIE
	extern	VOID	__security_init_cookie(VOID);

	if (dwReason == DLL_PROCESS_ATTACH)

		// https://msdn.microsoft.com/en-us/library/ms235362.aspx

		__security_init_cookie();
#endif
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	return DllMain(hModule, dwReason, lpReserved);
}
<<NOKEEP

MSC_DEMO.CON: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /DGSCOOKIE /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /UUNICODE /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".startup")

// https://msdn.microsoft.com/en-us/library/1dc22465.aspx

#pragma const_seg(".const")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/3ze4ytsc.aspx
// https://msdn.microsoft.com/en-us/library/6wd819wh.aspx
// https://msdn.microsoft.com/en-us/library/bky3b5dh.aspx

#ifdef UNICODE
extern	int	wmain(int argc, wchar_t *argv[], wchar_t *envp[]);
#else
extern	int	main(int argc, char *argv[], char *envp[]);
#endif // UNICODE

__declspec(noreturn)
#ifdef UNICODE

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

VOID	CDECL	wmainCRTStartup(VOID)
{
	static	wchar_t	*argv[] = {L"MSC_DEMO",
			           __LPREFIX(__FUNCDNAME__),
			           __LPREFIX(__FUNCSIG__),
			           __LPREFIX(__FUNCTION__),
			           __LPREFIX(__TIMESTAMP__),
			           NULL};
	static	wchar_t	*envp[] = {L"Name=Value", NULL};
#ifdef GSCOOKIE
	// https://msdn.microsoft.com/en-us/library/ms235362.aspx

	extern	VOID	__security_init_cookie(VOID);

	__security_init_cookie();
#endif
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(wmain(sizeof(argv) / sizeof(*argv) - 1, argv, envp));
}
#else
// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

VOID	CDECL	mainCRTStartup(VOID)
{
	static	char	*argv[] = {"MSC_DEMO",
			           __FUNCDNAME__,
			           __FUNCSIG__,
			           __FUNCTION__,
			           __TIMESTAMP__,
			           NULL};
	static	char	*envp[] = {"Name=Value", NULL};

	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(main(sizeof(argv) / sizeof(*argv) - 1, argv, envp));
}
#endif // UNICODE
<<NOKEEP

MSC_DEMO.UNI: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /DGSCOOKIE /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /wd4090 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".startup")

// https://msdn.microsoft.com/en-us/library/1dc22465.aspx

#pragma const_seg(".const")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(_alloca, memcpy, wcscpy, wcslen)

// https://msdn.microsoft.com/en-us/library/3ze4ytsc.aspx
// https://msdn.microsoft.com/en-us/library/6wd819wh.aspx
// https://msdn.microsoft.com/en-us/library/bky3b5dh.aspx

extern	int	wmain(int argc, wchar_t *argv[], wchar_t *envp[]);

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	CDECL	wmainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms683187.aspx

	wchar_t	const	*env = GetEnvironmentStringsW();

	// https://msdn.microsoft.com/en-us/library/ms683156.aspx

	wchar_t	const	*cmd = GetCommandLineW();

	wchar_t	const	*src = cmd;
	wchar_t	const	*var;
	wchar_t		*dst;
	unsigned int	cnt;
	unsigned int	esc = 0U;
	unsigned int	quo = 0U;

	unsigned int	argc;
	wchar_t	const	**argv;
	wchar_t	const	**envp;
#ifdef GSCOOKIE
	// https://msdn.microsoft.com/en-us/library/ms235362.aspx

	extern	VOID	__security_init_cookie(VOID);

	__security_init_cookie();
#endif
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	// https://msdn.microsoft.com/en-us/library/a1y7w461.aspx

	argc = (*cmd != L' ') && (*cmd != L'\t');

	while (*cmd != L'\0')		// count arguments
	{
		if ((quo == 0U)		// whitespace outside double quotes
		 && ((*cmd == L' ') || (*cmd == L'\t')))
		{
			do		// skip unquoted whitespace
				cmd++;
			while ((*cmd == L' ') || (*cmd == L'\t'));

			argc += (*cmd != L'\0');

			esc = 0U;

			continue;
		}
		else if (*cmd == L'\\')	// backslash
			esc ^= ~0U;
		else if ((esc == 0U)	// unescaped double quote
		      && (*cmd == L'"'))
			quo ^= ~0U;
		else			// regular character
			esc = 0U;
		cmd++;
	}

	// https://msdn.microsoft.com/en-us/library/wb1s57t5.aspx

	argv = (wchar_t	const **) _alloca((argc + 1U) * sizeof(*argv) + (cmd + 1U - src) * sizeof(**argv));

	argv[0] = dst = (wchar_t *) (argv + argc + 1U);

	argc = esc = quo = 0U;

	while (*src != L'\0')		// process arguments
	{
		if ((quo == 0U)		// whitespace outside double quotes?
		 && ((*src == L' ') || (*src == L'\t')))
		{
			*dst = L'\0';	// terminate current argument

			do		// skip unquoted whitespace
				src++;
			while ((*src == L' ') || (*src == L'\t'));

			if (*src != L'\0')
					// store address of next argument
				argv[++argc] = dst = src;

			esc = 0U;
		}
		else if (*src == L'\\')
		{
			*dst++ = *src++;
			esc++;		// count backslash
		}
		else if (*src == L'"')	// double quote?
		{
			dst -= (esc + 1U) / 2U;

			if ((esc & 1U) != 0U)
					// double quote preceeded by odd number
					//  of backslashes: keep half of them
					//   and the (escaped) double quote
				*dst++ = *src++;
			else		// double quote preceeded by even number
					//  of backslashes: keep half of them
				if ((*++src == L'"') && (quo != 0U))
					// double quote inside double quotes and
					//  followed by another double quote:
					//   keep single double quote
					*dst++ = *src++;
				else	// skip double quote and toggle state
					quo ^= ~0U;
			esc = 0U;
		}
		else			// regular character
		{
			*dst++ = *src++;
			esc = 0U;
		}
	}

	*dst = L'\0';			// terminate (last) argument

	argv[++argc] = NULL;		// store terminating NULL pointer
	envp = argv + argc;

	if (env != NULL)
	{
		// https://msdn.microsoft.com/en-us/library/78zh94ax.aspx

		for (cnt = 0U, var = env; *var != L'\0'; var += wcslen(var) + 1UL)
			if (*var != L'=')
				cnt++;	// count environment strings

		if (cnt > 0U)		// process environment strings
		{
			// https://msdn.microsoft.com/en-us/library/wb1s57t5.aspx

			envp = (wchar_t const **) _alloca((cnt + 1U) * sizeof(*envp));

			// https://msdn.microsoft.com/en-us/library/78zh94ax.aspx

			for (cnt = 0U, var = env; *var != L'\0'; var += wcslen(var) + 1U)
				if (*var != L'=')
					envp[cnt++] = var;

			envp[cnt] = (wchar_t *) NULL;
		}
	}

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(wmain(argc, argv, envp));
}
<<NOKEEP

MSC_DEMO.WIN: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /DGSCOOKIE /DUNICODE /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".startup")

// https://msdn.microsoft.com/en-us/library/1dc22465.aspx

#pragma const_seg(".const")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

extern	const	IMAGE_DOS_HEADER	__ImageBase;

// https://msdn.microsoft.com/en-us/library/ms633559.aspx

#ifdef UNICODE
extern	INT	WINAPI	wWinMain(HINSTANCE hInstance,
			         HINSTANCE hPrevInstance,
		                 LPWSTR    lpCmdLine,
		                 INT       nCmdShow);
#else
extern	INT	WINAPI	WinMain(HINSTANCE hInstance,
			        HINSTANCE hPrevInstance,
		                LPSTR     lpCmdLine,
		                INT       nCmdShow);
#endif // UNICODE

__declspec(noreturn)
#ifdef UNICODE
// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

VOID	CDECL	wWinMainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms686331.aspx

	STARTUPINFOW	si;
#ifdef GSCOOKIE
	// https://msdn.microsoft.com/en-us/library/ms235362.aspx

	extern	VOID	__security_init_cookie(VOID);

	__security_init_cookie();
#endif
	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	// https://msdn.microsoft.com/en-us/library/ms683230.aspx

	GetStartupInfoW(&si);

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx
	// https://msdn.microsoft.com/en-us/library/ms683156.aspx
	// https://msdn.microsoft.com/en-us/library/ms633559.aspx

	ExitProcess(wWinMain((HINSTANCE) &__ImageBase,
	                     (HINSTANCE) NULL,
	                     GetCommandLineW(),
	                     si.dwFlags & STARTF_USESHOWWINDOW ? si.wShowWindow : SW_SHOWDEFAULT));
}
#else
// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

VOID	CDECL	WinMainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms686331.aspx

	STARTUPINFOA	si;

	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	// https://msdn.microsoft.com/en-us/library/ms683230.aspx

	GetStartupInfoA(&si);

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx
	// https://msdn.microsoft.com/en-us/library/ms683156.aspx
	// https://msdn.microsoft.com/en-us/library/ms633559.aspx

	ExitProcess(WinMain((HINSTANCE) &__ImageBase,
	                    (HINSTANCE) NULL,
	                    GetCommandLineA(),
	                    si.dwFlags & STARTF_USESHOWWINDOW ? si.wShowWindow : SW_SHOWDEFAULT));
}
#endif // UNICODE
<<NOKEEP

MSC_DEMO.RTL: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /Fo$@ /GAFS /Gdwy /J /nologo /Oxy /Tc<< /W4 /we4013 /X /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".runtime")

#ifndef _WIN64
typedef	unsigned int	size_t;
#endif

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(__movsb, __movsw, __stosb, __stosw)

// https://msdn.microsoft.com/en-us/library/sctyh01s.aspx

#pragma function(memcpy, memset)

// https://msdn.microsoft.com/en-us/library/dswaw1wk.aspx

void	*memcpy(void *dst, void const *src, size_t cnt)
{
	// https://msdn.microsoft.com/en-us/library/hhta9830.aspx

	__movsb(dst, src, cnt);

	return dst;
}

// https://msdn.microsoft.com/en-us/library/1fdeehz6.aspx

void	*memset(void *dst, char src, size_t cnt)
{
	// https://msdn.microsoft.com/en-us/library/ywwcatsa.aspx

	__stosb(dst, src, cnt);

	return dst;
}

// https://msdn.microsoft.com/en-us/library/dswaw1wk.aspx

short	*wmemcpy(short *dst, short const *src, size_t cnt)
{
	// https://msdn.microsoft.com/en-us/library/adf7db3x.aspx

	__movsw(dst, src, cnt);

	return dst;
}

// https://msdn.microsoft.com/en-us/library/1fdeehz6.aspx

short	*wmemset(short *dst, short src, size_t cnt)
{
	// https://msdn.microsoft.com/en-us/library/k99wy47b.aspx

	__stosw(dst, src, cnt);

	return dst;
}
<<NOKEEP

MSC_DEMO.RTC: MSC_DEMO.MAK
	CL.EXE /analyze /Brepro /c /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /wd4100 /wd4047 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#ifdef _WIN64
#pragma comment(linker, "/ALTERNATENAME:_CRT_RTC_INITW=_CRT_RTC_INITW")
#else
#pragma comment(linker, "/ALTERNATENAME:__CRT_RTC_INITW=__CRT_RTC_INITW")
#endif

#include <rtcapi.h>

_RTC_ErrorNumber	enum
{
	_RTC_CHKSTK           = 0,
	_RTC_CVRT_LOSS_INFO,
	_RTC_CORRUPT_STACK,
	_RTC_UNINIT_LOCAL_USE,
	_RTC_CORRUPTED_ALLOCA
};

// https://msdn.microsoft.com/en-us/library/w68b74dy.aspx

// https://msdn.microsoft.com/en-us/library/a74161bs.aspx

char	const	*_RTC_GetErrDesc(_RTC_ErrorNumber errornumber)
{
	switch (errornumber)
	{
	case _RTC_CHKSTK:
		return "The stack pointer was wrong after returning from a function call.";	// _RTC_CHKSTK
	case _RTC_CVRT_LOSS_INFO:
		return "Data was lost when a type was converted to a smaller type.";
	case _RTC_CORRUPT_STACK:
		return "The stack near a local variable was corrupted.";
	case _RTC_UNINIT_LOCAL_USE:
		return "An uninitialized local variable was used.";
	case _RTC_CORRUPTED_ALLOCA:
		return "The stack around an alloca was corrupted.";
	default:
		return "Invalid or unknown error number";
	}
}

// https://msdn.microsoft.com/en-us/library/wz9dffa5.aspx

int	_RTC_NumErrors(void)
{
	return 1 + _RTC_CORRUPTED_ALLOCA;
}

// https://msdn.microsoft.com/en-us/library/t5f9bsz8.aspx

int	_RTC_SetErrorType(_RTC_ErrorNumber errornumber,
	                  int              errortype);

// https://msdn.microsoft.com/en-us/library/aazwhs1b.aspx

typedef	int	(*_RTC_error_fn) (int        errortype,
		                  char const *filename,
		                  int        linenumber,
		                  char const *moduleName,
		                  char const *format,
		                  ...);

int	_RTC_DefaultErrorFunctionA(int        errortype,
		                   char const *filename,
		                   int        linenumber,
		                   char const *moduleName,
		                   char const *format,
		                   ...)
{	// https://msdn.microsoft.com/en-us/library/f408b4et.aspx

	__debugbreak();

	return 0;
}

static	_RTC_error_fn	_RTC_pfnA = 0;

_RTC_error_fn	_RTC_SetErrorFunc(_RTC_error_fn function)
{
	_RTC_error_fn	current = _RTC_pfnA;

	_RTC_pfnA = 0 != function ? function : _RTC_DefaultErrorFunctionA;

	return _RTC_DefaultErrorFunctionA != current ? current : 0;
}

// https://msdn.microsoft.com/en-us/library/aazwhs1b.aspx

typedef	int	(*_RTC_error_fnW) (int           errortype,
		                   wchar_t const *filename,
		                   int           linenumber,
		                   wchar_t const *moduleName,
		                   wchar_t const *format,
		                   ...);

static	_RTC_error_fnW	_RTC_pfn = 0;

_RTC_error_fnW	_RTC_SetErrorFuncW(_RTC_error_fnW function)
{
	_RTC_error_fnW	current = _RTC_pfnW;

	_RTC_pfnW = 0 != function ? function : _RTC_DefaultErrorFunctionW;

	return _RTC_DefaultErrorFunctionW != current ? current : 0;
}

int	_RTC_DefaultErrorFunctionW(int           errortype,
		                   wchar_t const *filename,
		                   int           linenumber,
		                   wchar_t const *moduleName,
		                   wchar_t const *format,
		                   ...)
{	// https://msdn.microsoft.com/en-us/library/f408b4et.aspx

	__debugbreak();

	return 0;
}

// https://msdn.microsoft.com/en-us/library/azff25ez.aspx

_RTC_error_fn	_CRT_RTC_INIT(void *reserved0,
		              void **reserved1,
		              int  reserved2,
		              int  reserved3,
		              int  reserved4)
{
	return _RTC_DefaultErrorFunctionA;
}

// https://msdn.microsoft.com/en-us/library/azff25ez.aspx

_RTC_error_fnW	_CRT_RTC_INITW(void *reserved0,
		               void **reserved1,
		               int  reserved2,
		               int  reserved3,
		               int  reserved4)
{
	return _RTC_DefaultErrorFunctionW;
}

static	int	_RTC_init = 0;

void	_RTC_Initialize(void)
{
	if (_RTC_init != 0)
		return;

	_RTC_SetErrorFuncW(CRT_RTC_INITW(0, 0, 0, 1, 0));

	_RTC_init = ~0;
}

void	_RTC_Shutdown(void)
{
}

// https://msdn.microsoft.com/en-us/library/40ky6s47.aspx
<<NOKEEP

MSC_DEMO.TLS: MSC_DEMO.MAK # NOTE: only for documentation!
	CL.EXE /analyze /Brepro /c /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /wd4100 /wd4047 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/6yh4a9k1.aspx
// https://msdn.microsoft.com/en-us/library/gg463119.aspx
// https://msdn.microsoft.com/en-us/library/ms680547.aspx

// Offset of 'ThreadLocalStoragePointer' member in TEB (Thread Environment Block):
//  44 for I386, referenced in compiled code, 88 for AMD64, not referenced!

extern	OFFSET	_tls_array;

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx
// https://msdn.microsoft.com/en-us/library/sf9b18xk.aspx

#pragma comment(linker, "/SECTION:.tls,!w")

// https://msdn.microsoft.com/en-us/library/thfhx4st.aspx

#pragma data_seg(".tls")

BYTE	*_tls_start = NULL;

#pragma data_seg(".tls$$~~~")

BYTE	*_tls_end = NULL;

#pragma data_seg()

// NOTE: assigned by the module loader!

DWORD	_tls_index = 'VOID';

// https://msdn.microsoft.com/en-us/library/1dc22465.aspx

#pragma const_seg(".rdata$$T")

const	PIMAGE_TLS_CALLBACK	_tls_callbacks[] = {NULL};

// BUG: the module loader discards the 'SizeOfZeroFill' member!

const	IMAGE_TLS_DIRECTORY	_tls_used = {&_tls_start,
				             &_tls_end,
				             &_tls_index,
				             _tls_callbacks,
				             'VOID',
				             0UL};
#pragma const_seg()
<<NOKEEP

MSC_DEMO.LCU: MSC_DEMO.MAK # NOTE: only for documentation!
	CL.EXE /analyze /Brepro /c /DLCU /Fo$@ /GAFS /Gdwy /nologo /Oxy /Tc<< /W4 /wd4100 /wd4047 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/azbwewbt.aspx

#pragma bss_seg(".bss")

// https://msdn.microsoft.com/en-us/library/s20kdbse.aspx

#pragma code_seg(".runtime")

// https://msdn.microsoft.com/en-us/library/1dc22465.aspx

#pragma const_seg(".const")

// https://msdn.microsoft.com/en-us/library/thfhx4st.aspx

#pragma data_seg(".cookie")

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#ifndef EXCEPTION_STACK_BUFFER_OVERRUN
#define EXCEPTION_STACK_BUFFER_OVERRUN		0xC0000409L
#endif

// https://msdn.microsoft.com/en-us/library/cc779664.aspx
// https://msdn.microsoft.com/en-us/library/ff549646.aspx

#define FLG_STOP_ON_EXCEPTION		0x00000001UL
#define FLG_SHOW_LDR_SNAPS		0x00000002UL
#define FLG_DEBUG_INITIAL_COMMAND	0x00000004UL
#define FLG_STOP_ON_HUNG_GUI		0x00000008UL
#define FLG_HEAP_ENABLE_TAIL_CHECK	0x00000010UL
#define FLG_HEAP_ENABLE_FREE_CHECK	0x00000020UL
#define FLG_HEAP_VALIDATE_PARAMETERS	0x00000040UL
#define FLG_HEAP_VALIDATE_ALL		0x00000080UL
#define FLG_APPLICATION_VERIFIER	0x00000100UL
#define FLG_MONITOR_SILENT_PROCESS_EXIT	0x00000200UL
#define FLG_POOL_ENABLE_TAGGING		0x00000400UL
#define FLG_HEAP_ENABLE_TAGGING		0x00000800UL
#define FLG_USER_STACK_TRACE_DB		0x00001000UL
#define FLG_KERNEL_STACK_TRACE_DB	0x00002000UL
#define FLG_MAINTAIN_OBJECT_TYPELIST	0x00004000UL
#define FLG_HEAP_ENABLE_TAG_BY_DLL	0x00008000UL
#define FLG_DISABLE_STACK_EXTENSION	0x00010000UL
#define FLG_ENABLE_CSRDEBUG		0x00020000UL
#define FLG_ENABLE_KDEBUG_SYMBOL_LOAD	0x00040000UL
#define FLG_DISABLE_PAGE_KERNEL_STACKS	0x00080000UL
#define FLG_ENABLE_SYSTEM_CRIT_BREAKS	0x00100000UL
#define FLG_HEAP_DISABLE_COALESCING	0x00200000UL
#define FLG_ENABLE_CLOSE_EXCEPTIONS	0x00400000UL
#define FLG_ENABLE_EXCEPTION_LOGGING	0x00800000UL
#define FLG_ENABLE_HANDLE_TYPE_TAGGING	0x01000000UL
#define FLG_HEAP_PAGE_ALLOCS		0x02000000UL
#define FLG_DEBUG_INITIAL_COMMAND_EX	0x04000000UL
#define FLG_DISABLE_DBGPRINT		0x08000000UL
#define FLG_CRITSEC_EVENT_CREATION	0x10000000UL
#if _WIN32_WINNT > 0x0502
#define FLG_STOP_ON_UNHANDLED_EXCEPTION	0x20000000UL
#else
#define FLG_LDR_TOP_DOWN		0x20000000UL
#endif
#define FLG_ENABLE_HANDLE_EXCEPTIONS	0x40000000UL
#define FLG_DISABLE_PROTDLLS		0x80000000UL

// https://msdn.microsoft.com/en-us/library/ms684179.aspx

#ifndef LOAD_LIBRARY_SEARCH_DEFAULT_DIRS
#define LOAD_LIBRARY_SEARCH_DLL_LOAD_DIR		0x00000100UL
#define LOAD_LIBRARY_SEARCH_APPLICATION_DIR		0x00000200UL
#define LOAD_LIBRARY_SEARCH_USER_DIRS			0x00000400UL
#define LOAD_LIBRARY_SEARCH_SYSTEM32			0x00000800UL
#define LOAD_LIBRARY_SEARCH_DEFAULT_DIRS		0x00001000UL
#define LOAD_LIBRARY_SEARCH_SAFE_CURRENT_DIRS		0x00002000UL
#define LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER	0x00004000UL
#define LOAD_LIBRARY_OS_INTEGRITY_CONTINUITY		0x00008000UL
#endif

#ifndef _WIN64
DWORD_PTR	__security_cookie = 0xBB40E64EUL;
		               // = 3141592654 = 10**9 * pi

// https://msdn.microsoft.com/en-us/library/9a89h429.aspx

extern	LPVOID	__safe_se_handler_table[];
extern	BYTE	__safe_se_handler_count;

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_32
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD	DeCommitFreeBlockThreshold;
	DWORD	DeCommitTotalFreeThreshold;
	DWORD	LockPrefixTable;
	DWORD	MaximumAllocationSize;
	DWORD	VirtualMemoryThreshold;
	DWORD	ProcessHeapFlags;
	DWORD	ProcessAffinityMask;
	WORD	CSDVersion;
#if LCU > 2				// Redstone 1 (1607)
	WORD	DependentLoadFlags;
#else
	WORD	Reserved1;
#endif
	DWORD	EditList;
	DWORD	SecurityCookie;
	DWORD	SEHandlerTable;
	DWORD	SEHandlerCount;
#if LCU > 0				// Threshold 1 (1507)
	DWORD	GuardCFCheckFunctionPointer;
	DWORD	GuardCFDispatchFunctionPointer;
	DWORD	GuardCFFunctionTable;
	DWORD	GuardCFFunctionCount;
	DWORD	GuardFlags;
#if LCU > 1				// Threshold 2 (1511)
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
#if LCU > 2				// Redstone 1 (1607)
	DWORD	GuardAddressTakenIatEntryTable;
	DWORD	GuardAddressTakenIatEntryCount;
	DWORD	GuardLongJumpTargetTable;
	DWORD	GuardLongJumpTargetCount;
					//
	DWORD	DynamicValueRelocTable;
	DWORD	CHPEMetadataPointer;
#if LCU > 3				// Redstone 2 (1703)
	DWORD	GuardRFFailureRoutine;
	DWORD	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
#if LCU > 4				// Redstone 3 (1709)
	DWORD	Reserved3;
	DWORD	EnclaveConfigurationPointer;
#if LCU > 5				// Redstone 4 (1803)
	DWORD	VolatileMetadataPointer;
#if LCU > 6				// Redstone 5 (1809)
	DWORD	GuardEHContinuationTable;
	DWORD	GuardEHContinuationCount;
					// Titanium (1903)
					// Vanadium (1909)
					// Vibranium 1 (2004)
					// Vibranium 2 (20H2)
#if LCU > 7				// Vibranium 3 (21H1)
	DWORD	GuardXFGCheckFunctionPointer;
	DWORD	GuardXFGDispatchFunctionPointer;
	DWORD	GuardXFGTableDispatchFunctionPointer;
#if LCU > 8				// Vibranium 4 (21H2)
	DWORD	CastGuardOsDeterminedFailureMode;
#if LCU > 9				// Vibranium 5 (22H2)
	DWORD	GuardMemcpyFunctionPointer;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
} _load_config_used = {sizeof(_load_config_used),
                       'DEMO',	// 0x44454D4F = 2006-04-18 20:34:23 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL,
                       FLG_ENABLE_CLOSE_EXCEPTIONS,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       HEAP_GENERATE_EXCEPTIONS,
                       0UL,
                       0U,
                       LOAD_LIBRARY_SEARCH_SYSTEM32,
                       0UL,
                       &__security_cookie,
                       __safe_se_handler_table,
                       &__safe_se_handler_count,
                       0UL,
                       0UL,
                       0UL,
                       0UL,
                       0UL};
#else // _WIN64
DWORD_PTR	__security_cookie = 0x00002B992DDFA232ULL;
		               // = 3141592653589793238 >> 16
		               // = 10**18 / 2**16 * pi

// https://msdn.microsoft.com/en-us/library/ms680328.aspx

const	struct	_IMAGE_LOAD_CONFIG_DIRECTORY_64
{
	DWORD	Size;
	DWORD	TimeDateStamp;
	WORD	MajorVersion;
	WORD	MinorVersion;
	DWORD	GlobalFlagsClear;
	DWORD	GlobalFlagsSet;
	DWORD	CriticalSectionDefaultTimeout;
	DWORD64	DeCommitFreeBlockThreshold;
	DWORD64	DeCommitTotalFreeThreshold;
	DWORD64	LockPrefixTable;
	DWORD64	MaximumAllocationSize;
	DWORD64	VirtualMemoryThreshold;
	DWORD64	ProcessAffinityMask;
	DWORD	ProcessHeapFlags;
	WORD	CSDVersion;
#if LCU > 2
	WORD	DependentLoadFlags;
#else
	WORD	Reserved1;
#endif
	DWORD64	EditList;
	DWORD64	SecurityCookie;
	DWORD64	SEHandlerTable;
	DWORD64	SEHandlerCount;
#if LCU > 0				// Threshold 1 (1507)
	DWORD64	GuardCFCheckFunctionPointer;
	DWORD64	GuardCFDispatchFunctionPointer;
	DWORD64	GuardCFFunctionTable;
	DWORD64	GuardCFFunctionCount;
	DWORD	GuardFlags;
#if LCU > 1				// Threshold 2 (1511)
	struct	// _IMAGE_LOAD_CONFIG_CODE_INTEGRITY
	{
		WORD	Flags;
		WORD	Catalog;
		DWORD	CatalogOffset;
		DWORD	Reserved;
	} CodeIntegrity;
#if LCU > 2				// Redstone 1 (1607)
	DWORD64	GuardAddressTakenIatEntryTable;
	DWORD64	GuardAddressTakenIatEntryCount;
	DWORD64	GuardLongJumpTargetTable;
	DWORD64	GuardLongJumpTargetCount;
					//
	DWORD64	DynamicValueRelocTable;
	DWORD64	CHPEMetadataPointer;
#if LCU > 3				// Redstone 2 (1703)
	DWORD64	GuardRFFailureRoutine;
	DWORD64	GuardRFFailureRoutineFunctionPointer;
	DWORD	DynamicValueRelocTableOffset;
	WORD	DynamicValueRelocTableSection;
	WORD	Reserved2;
	DWORD64	GuardRFVerifyStackPointerFunctionPointer;
	DWORD	HotPatchTableOffset;
#if LCU > 4				// Redstone 3 (1709)
	DWORD	Reserved3;
	DWORD64	EnclaveConfigurationPointer;
#if LCU > 5				// Redstone 4 (1803)
	DWORD64	VolatileMetadataPointer;
#if LCU > 6				// Redstone 5 (1809)
	DWORD64	GuardEHContinuationTable;
	DWORD64	GuardEHContinuationCount;
					// Titanium (1903)
					// Vanadium (1909)
					// Vibranium 1 (2004)
					// Vibranium 2 (20H2)
#if LCU > 7				// Vibranium 3 (21H1)
	DWORD64	GuardXFGCheckFunctionPointer;
	DWORD64	GuardXFGDispatchFunctionPointer;
	DWORD64	GuardXFGTableDispatchFunctionPointer;
#if LCU > 8				// Vibranium 4 (21H2)
	DWORD64	CastGuardOsDeterminedFailureMode;
#if LCU > 9				// Vibranium 5 (22H2)
	DWORD64	GuardMemcpyFunctionPointer;
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
#endif
} _load_config_used = {sizeof(_load_config_used),
                       'DEMO',	// 0x44454D4F = 2006-04-18 20:34:23 UTC
                       _MSC_VER / 100,
                       _MSC_VER % 100,
                       0UL,
                       FLG_ENABLE_CLOSE_EXCEPTIONS,
                       0UL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       HEAP_GENERATE_EXCEPTIONS,
                       0U,
                       LOAD_LIBRARY_SEARCH_SYSTEM32,
                       0ULL,
                       &__security_cookie,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0ULL,
                       0UL};
#endif // _WIN64

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(_AddressOfReturnAddress, _ReturnAddress)

// https://msdn.microsoft.com/en-us/library/8dbf701c.aspx
// https://msdn.microsoft.com/en-us/library/aa290051.aspx

VOID	__security_check_cookie(DWORD_PTR _stackcookie)
{
	if (_stackcookie == __security_cookie)
		return;

	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");
#ifdef FAST_FAIL_STACK_COOKIE_CHECK_FAILURE
	// https://msdn.microsoft.com/en-us/library/dn774154.aspx

	__fastfail(FAST_FAIL_STACK_COOKIE_CHECK_FAILURE);
#elif FAIL_FAST_GENERATE_EXCEPTION_ADDRESS
	// https://msdn.microsoft.com/en-us/library/dd941688.aspx

	RaiseFailFastException((EXCEPTION_RECORD *) NULL, (CONTEXT *) NULL, FAIL_FAST_GENERATE_EXCEPTION_ADDRESS);
#else
	// https://msdn.microsoft.com/en-us/library/ms680552.aspx

	RaiseException(EXCEPTION_STACK_BUFFER_OVERRUN, EXCEPTION_NONCONTINUABLE, 1UL, _AddressOfReturnAddress());
#endif
	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(ERROR_STACK_BUFFER_OVERRUN);
}

// https://msdn.microsoft.com/en-us/library/ms235362.aspx

VOID	__security_init_cookie(VOID)
{
#ifdef _WIN64
	if ((__security_cookie != 3141592653589793238ULL >> 16)
#else
	if ((__security_cookie != 3141592654UL)
#endif
	 && (__security_cookie != 0))
		return;

	// https://msdn.microsoft.com/en-us/library/aa363362.aspx

	OutputDebugStringA("MSC_DEMO: function " __FUNCDNAME__ "\n");

	// https://msdn.microsoft.com/en-us/library/bb432254.aspx
	// https://msdn.microsoft.com/en-us/library/bb432242.aspx
	// https://msdn.microsoft.com/en-us/library/s975zw7k.aspx
	// https://msdn.microsoft.com/en-us/library/64ez38eh.aspx

	__security_cookie = (DWORD_PTR) EncodePointer(_AddressOfReturnAddress())
	                  ^ (DWORD_PTR) DecodePointer(_ReturnAddress());
#ifdef _WIN64
	__security_cookie >>= 16;
#endif
}
<<NOKEEP

MSC_DEMO.X86: MSC_DEMO.MAK
	ML.EXE /Brepro /Cp /Cx /c /coff /Fo$@ /Gy /nologo /safeseh /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.686
	.model	flat; C

; https://msdn.microsoft.com/en-us/library/9a89h429.aspx

	extern	___safe_se_handler_count :abs
	extern	___safe_se_handler_table :ptr proc

; https://msdn.microsoft.com/en-us/library/ms680328.aspx

_lcu_32	struct	4
	dword	sizeof _lcu_32
	dword	"DEMO"
	word	0, 815
	dword	0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	word	0, 2048			; LOAD_LIBRARY_SEARCH_SYSTEM32
	dword	0
	dword	offset ___security_cookie
	dword	offset ___safe_se_handler_table
	dword	offset ___safe_se_handler_count
	dword	0, 0, 0, 0, 0
_lcu_32	ends

	.const

	public	__load_config_used
__load_config_used \
	_lcu_32	<>

	.data

	public	___security_cookie
___security_cookie \
	dword	3141592654

	.code

; https://msdn.microsoft.com/en-us/library/8dbf701c.aspx
; https://msdn.microsoft.com/en-us/library/aa290051.aspx

@__security_check_cookie@4 \
	proc	public			; void __security_check_cookie(dword cookie)

	cmp	ecx, ___security_cookie
	jne	short fastfail
	ret

; https://msdn.microsoft.com/en-us/library/dn774154.aspx

fastfail:
	mov	ecx, 2			; ecx = FAST_FAIL_STACK_COOKIE_CHECK_FAILURE
	int	41
	ud2

@__security_check_cookie@4 \
	endp

; https://msdn.microsoft.com/en-us/library/ms235362.aspx

___security_init_cookie \
	proc	public			; void __security_init_cookie(void)

	mov	eax, ___security_cookie
	cmp	eax, 3141592654
	je	short init

	test	eax, eax
	jne	short exit
init:
	rdtsc				; eax = low dword of time stamp counter,
					; edx = high dword of time stamp counter
	xor	eax, edx		; eax = pseudo random number
	mov	___security_cookie, eax
exit:
	ret

___security_init_cookie	\
	endp
	end
<<NOKEEP

MSC_DEMO.FPU: MSC_DEMO.MAK
	ML.EXE /Brepro /Cp /Cx /c /coff /Fo$@ /Gy /nologo /safeseh /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.686
	.model	flat, C

single	record	sign:1, exponent:8, mantissa:23

bias	equ	1 shl (width exponent - 1) - 1

	.const

	public	_fltused
_fltused dword	9876h

	.code

; https://msdn.microsoft.com/en-us/library/dn727675.aspx

; MSC internal intrinsic _CIacos():
; receives argument in FPU st(0), returns result in FPU st(0)

; NOTE: _CIacos() returns correct result for 0.0 and 1.0

_CIacos	proc	public

	fld	st(0)			; st(0) = st(1) = argument
	fmul	st(0), st(0)		; st(0) = argument**2,
					; st(1) = argument
	fld1				; st(0) = 1.0,
					; st(1) = argument**2,
					; st(2) = argument
	fsubrp	st(1), st(0)		; st(0) = 1.0 - argument**2,
					; st(1) = argument
	fsqrt				; st(0) = square root of (1.0 - argument**2),
					; st(1) = argument
	fxch	st(1)			; st(0) = argument,
					; st(1) = square root of (1.0 - argument**2)
	fpatan				; st(0) = inverse circular cosine of argument
	ret

_CIacos	endp

; MSC internal intrinsic _CIasin():
; receives argument in FPU st(0), returns result in FPU st(0)

; NOTE: _CIasin() returns correct result for 0.0 and 1.0

_CIasin	proc	public

	fld	st(0)			; st(0) = st(1) = argument
	fmul	st(0), st(0)		; st(0) = argument**2,
					; st(1) = argument
	fld1				; st(0) = 1.0,
					; st(1) = argument**2,
					; st(2) = argument
	fsubrp	st(1), st(0)		; st(0) = 1.0 - argument**2,
					; st(1) = argument
	fsqrt				; st(0) = square root of (1.0 - argument**2),
					; st(1) = argument
	fpatan				; st(0) = inverse circular sine of argument
	ret

_CIasin	endp

; https://msdn.microsoft.com/en-us/library/ff770582.aspx

; MSC internal intrinsic _CIatan():
; receives argument in FPU st(0), returns result in FPU st(0)

; NOTE: _CIatan() returns correct result for 0.0 and INFINITY

_CIatan	proc	public

	fld1				; st(0) = 1.0,
					; st(1) = argument
	fpatan				; st(0) = inverse circular tangent of (argument / 1.0)
	ret

_CIatan	endp

; https://msdn.microsoft.com/en-us/library/ff770581.aspx

; MSC internal intrinsic _CIatan2():
; receives arguments in FPU st(0) and st(1), returns result in FPU st(0)

; NOTE: _CIatan2() returns correct result for 0.0 and INFINITY

_CIatan2 proc	public

	fxch	st(1)			; st(0) = denominator,
					; st(1) = numerator
	fpatan				; st(0) = inverse circular tangent of (numerator / denominator)
	ret

_CIatan2 endp

; https://msdn.microsoft.com/en-us/library/ff770589.aspx

; MSC internal intrinsic _CIcos():
; receives argument in FPU st(0), returns result in FPU st(0)

_CIcos	proc	public

	fcos				; st(0) = cosine of argument
	fstsw	ax			; ax = FPU status word,
					; ah = B:C3:T:O:P:C2:C1:C0
	sahf				; SF:ZF:0:AF:0:PF:1:CF = ah
	jnp	short exit		; |argument| < 2**63?
tau:
	fld1				; st(0) = 1.0,
					; st(1) = argument
	fldpi				; st(0) = pi,
					; st(1) = 1.0,
					; st(2) = argument
	fscale				; st(0) = pi * 2**1,
					; st(1) = 1.0,
					; st(2) = argument
	fstp	st(1)			; st(0) = pi * 2**1,
					; st(1) = argument
	fxch	st(1)			; st(0) = argument,
					; st(1) = pi * 2**1
reduce:
	fprem1				; st(0) = argument modulo (pi * 2**1)
					;       = argument',
					; st(1) = pi * 2**1
	fstsw	ax			; ax = FPU status word,
					; ah = B:C3:T:O:P:C2:C1:C0
	sahf				; SF:ZF:0:AF:0:PF:1:CF = ah
	jp	short reduce		; |argument'| > pi?

	fstp	st(1)			; st(0) = argument'
	fcos				; st(0) = cosine of argument'
exit:
	ret

_CIcos	endp

; https://msdn.microsoft.com/en-us/library/dn727675.aspx

; MSC internal intrinsic _CIcosh():
; receives argument in FPU st(0), returns result in FPU st(0)

_CIcosh	proc	public

	call	_CIexp			; st(0) = e**argument
	fld1				; st(0) = 1.0,
					; st(1) = e**argument
	fdiv	st(0), st(1)		; st(0) = 1.0 / e**argument = e**-argument,
					; st(1) = e**argument
	faddp	st(1), st(0)		; st(0) = e**argument + e**-argument
	push	(bias - 1) shl width mantissa
					; [esp] = 0x3F000000
					;       = 0.5F
	fmul	real4 ptr [esp]		; st(0) = hyperbolic cosine of argument
	pop	eax
	ret

_CIcosh	endp

; https://msdn.microsoft.com/en-us/library/ff770600.aspx

; MSC internal intrinsic _CIexp():
; receives argument in FPU st(0), returns result in FPU st(0)

; NOTE: _CIexp() returns correct result for INFINITY

_CIexp	proc	public

	fldl2e				; st(0) = log2(e),
					; st(1) = exponent
	fmulp	st(1), st(0)		; st(0) = exponent * log2(e)
if 0
	fld1				; st(0) = 1.0,
					; st(1) = exponent * log2(e)
	fld	st(1)			; st(0) = exponent * log2(e),
					; st(1) = 1.0,
					; st(2) = exponent * log2(e)
	fprem				; st(0) = (exponent * log2(e)) modulo 1.0,
					; st(1) = 1.0,
					; st(2) = exponent * log2(e)
	f2xm1				; st(0) = 2.0**((exponent * log2(e)) modulo 1.0) - 1.0,
					; st(1) = 1.0,
					; st(2) = exponent * log2(e)
	faddp	st(1), st(0)		; st(0) = 2.0**((exponent * log2(e)) modulo 1.0),
					; st(1) = exponent * log2(e)
	fscale				; st(0) = e**exponent,
					; st(1) = exponent * log2(e)
else
	fld	st(0)			; st(0) = st(1) = exponent * log2(e)
	frndint				; st(0) = integer(exponent * log2(e)),
					; st(1) = exponent * log2(e)
	fsub	st(1), st(0)		; st(0) = integer(exponent * log2(e)),
					; st(1) = fraction(exponent * log2(e))
	fxch	st(1)			; st(0) = fraction(exponent * log2(e)),
					; st(1) = integer(exponent * log2(e))
	f2xm1				; st(0) = 2.0**fraction(exponent * log2(e)) - 1.0,
					; st(1) = integer(exponent * log2(e))
	fld1				; st(0) = 1.0,
					; st(1) = 2.0**fraction(exponent * log2(e)) - 1.0,
					; st(2) = integer(exponent * log2(e))
	faddp	st(1), st(0)		; st(0) = 2.0**fraction(exponent * log2(e)),
					; st(1) = integer(exponent * log2(e))
	fscale				; st(0) = e**exponent,
					; st(1) = integer(exponent * log2(e))
endif
	fstp	st(1)			; st(0) = e**exponent
	ret

_CIexp	endp

; https://msdn.microsoft.com/en-us/library/ff770591.aspx

; MSC internal intrinsic _CIfmod():
; receives arguments in FPU st(0) and st(1), returns result in FPU st(0)

_CIfmod	proc	public

reduce:
	fprem				; st(0) = remainder,
					; st(1) = divisor
	fstsw	ax			; ax = FPU status word,
					; ah = B:C3:T:O:P:C2:C1:C0
	sahf				; SF:ZF:0:AF:0:PF:1:CF = ah
	jp	short reduce

	fstp	st(1)			; st(0) = remainder
	ret

_CIfmod	endp

; https://msdn.microsoft.com/en-us/library/ff770580.aspx

; MSC internal intrinsic _CIlog():
; receives argument in FPU st(0), returns result in FPU st(0)

_CIlog	proc	public

	fldln2				; st(0) = ln(2.0),
					; st(1) = argument
	fxch	st(1)			; st(0) = argument,
					; st(1) = ln(2.0)
	fyl2x				; st(0) = natural logarithm of argument
	ret

_CIlog	endp

; https://msdn.microsoft.com/en-us/library/ff770578.aspx

; MSC internal intrinsic _CIlog10():
; receives argument in FPU st(0), returns result in FPU st(0)

_CIlog10 proc	public

	fldlg2				; st(0) = log10(2.0),
					; st(1) = argument
	fxch	st(1)			; st(0) = argument,
					; st(1) = log10(2.0)
	fyl2x				; st(0) = logarithm to base 10 of argument
	ret

_CIlog10 endp

; https://msdn.microsoft.com/en-us/library/ff770583.aspx

; MSC internal intrinsic _CIpow():
; receives arguments in FPU st(0) and st(1), returns result in FPU st(0)

_CIpow	proc	public

	fxch	st(1)			; st(0) = base,
					; st(1) = exponent
	fyl2x				; st(0) = exponent * log2(base)
	fld1				; st(0) = 1.0,
					; st(1) = exponent * log2(base)
	fld	st(1)			; st(0) = exponent * log2(base),
					; st(1) = 1.0,
					; st(2) = exponent * log2(base)
	fprem				; st(0) = (exponent * log2(base)) modulo 1.0,
					; st(1) = 1.0,
					; st(2) = exponent * log2(base)
	f2xm1				; st(0) = 2.0**((exponent * log2(base)) modulo 1.0) - 1.0,
					; st(1) = 1.0,
					; st(2) = exponent * log2(base)
	faddp	st(1), st(0)		; st(0) = 2.0**((exponent * log2(base)) modulo 1.0),
					; st(1) = exponent * log2(base)
	fscale				; st(0) = base**exponent,
					; st(1) = exponent * log2(base)
	fstp	st(1)			; st(0) = base**exponent
	ret

_CIpow	endp

; https://msdn.microsoft.com/en-us/library/ff770597.aspx

; MSC internal intrinsic _CIsin():
; receives argument in FPU st(0), returns result in FPU st(0)

_CIsin	proc	public

	fsin				; st(0) = sine of argument
	fstsw	ax			; ax = FPU status word,
					; ah = B:C3:T:O:P:C2:C1:C0
	sahf				; SF:ZF:0:AF:0:PF:1:CF = ah
	jnp	short exit		; |argument| < 2**63?
tau:
	fld1				; st(0) = 1.0,
					; st(1) = argument
	fldpi				; st(0) = pi,
					; st(1) = 1.0,
					; st(2) = argument
	fscale				; st(0) = pi * 2**1,
					; st(1) = 1.0,
					; st(2) = argument
	fstp	st(1)			; st(0) = pi * 2**1,
					; st(1) = argument
	fxch	st(1)			; st(0) = argument,
					; st(1) = pi * 2**1
reduce:
	fprem1				; st(0) = argument modulo (pi * 2**1)
					;       = argument',
					; st(1) = pi * 2**1
	fstsw	ax			; ax = FPU status word,
					; ah = B:C3:T:O:P:C2:C1:C0
	sahf				; SF:ZF:0:AF:0:PF:1:CF = ah
	jp	short reduce		; |argument'| > pi?

	fstp	st(1)			; st(0) = argument'
	fsin				; st(0) = sine of argument'
exit:
	ret

_CIsin	endp

; https://msdn.microsoft.com/en-us/library/dn727675.aspx

; MSC internal intrinsic _CIsinh():
; receives argument in FPU st(0), returns result in FPU st(0)

_CIsinh	proc	public

	call	_CIexp			; st(0) = e**argument
	fld1				; st(0) = 1.0,
					; st(1) = e**argument
	fdiv	st(0), st(1)		; st(0) = 1.0 / e**argument = e**-argument,
					; st(1) = e**argument
	fsubp	st(1), st(0)		; st(0) = e**argument - e**-argument
	push	(bias - 1) shl width mantissa
					; [esp] = 0x3F000000
					;       = 0.5F
	fmul	real4 ptr [esp]		; st(0) = hyperbolic sine of argument
	pop	eax
	ret

_CIsinh	endp

; https://msdn.microsoft.com/en-us/library/ff770588.aspx

; MSC internal intrinsic _CIsqrt():
; receives argument in FPU st(0), returns result in FPU st(0)

_CIsqrt	proc	public

	fsqrt				; st(0) = square root of radicand
	ret

_CIsqrt	endp

; https://msdn.microsoft.com/en-us/library/ff770595.aspx

; MSC internal intrinsic _CItan():
; receives argument in FPU st(0), returns result in FPU st(0)

_CItan	proc	public

	fptan				; st(0) = 1.0,
					; st(1) = tangent of argument
	fstsw	ax			; ax = FPU status word,
					; ah = B:C3:T:O:P:C2:C1:C0
	sahf				; SF:ZF:0:AF:0:PF:1:CF = ah
	jnp	short done		; |argument| < 2**63?
tau:
	fld1				; st(0) = 1.0,
					; st(1) = argument
	fldpi				; st(0) = pi,
					; st(1) = 1.0,
					; st(2) = argument
	fscale				; st(0) = pi * 2**1,
					; st(1) = 1.0,
					; st(2) = argument
	fstp	st(1)			; st(0) = pi * 2**1,
					; st(1) = argument
	fxch	st(1)			; st(0) = argument,
					; st(1) = pi * 2**1
reduce:
	fprem1				; st(0) = argument modulo (pi * 2**1)
					;       = argument',
					; st(1) = pi * 2**1
	fstsw	ax			; ax = FPU status word,
					; ah = B:C3:T:O:P:C2:C1:C0
	sahf				; SF:ZF:0:AF:0:PF:1:CF = ah
	jp	short reduce		; |argument'| > pi?

	fstp	st(1)			; st(0) = argument'
	fptan				; st(0) = 1.0,
					; st(1) = tangent of argument'
done:
	fstp	st(0)			; st(0) = tangent of argument
	ret

_CItan	endp

; https://msdn.microsoft.com/en-us/library/dn727675.aspx

; MSC internal intrinsic _CItanh():
; receives argument in FPU st(0), returns result in FPU st(0)

_CItanh	proc	public

	call	_CIexp			; st(0) = e**argument
	fmul	st(0), st(0)		; st(0) = e**argument * e**argument
					;       = e**(argument + argument)
	fld1				; st(0) = 1.0,
					; st(1) = e**(argument + argument)
	fadd	st(1), st(0)		; st(0) = 1.0,
					; st(1) = e**(argument + argument) + 1.0
	fadd	st(0), st(0)		; st(0) = 2.0,
					; st(1) = e**(argument + argument) + 1.0
	fdivrp	st(1), st(0)		; st(0) = 2.0 / (e**(argument + argument) + 1.0)
	fld1				; st(0) = 1.0,
					; st(1) = 2.0 / (e**(argument + argument) + 1.0)
	fsubrp	st(1), st(0)		; st(0) = 1.0 - 2.0 / (e**(argument + argument) + 1.0)
					;       = hyperbolic tangent of argument
	ret

_CItanh	endp

; MSC internal intrinsic _ftol():
; receives argument in FPU st(0), returns result in eax

; NOTE: fistp rounds to nearest (even) integer!

_ftol	proc	public

	push	eax
	fistp	dword ptr [esp]		; [esp] = integer(argument)
	pop	eax			; eax = integer(argument)
	ret

_ftol	endp

; MSC internal intrinsic _ftol2():
; receives argument in FPU st(0), returns result in edx:eax

; NOTE: fistp rounds to nearest (even) integer!

_ftol2	proc	public

	push	edx
	push	eax
	fistp	qword ptr [esp]		; [esp] = integer(argument)
	pop	eax
	pop	edx			; edx:eax = integer(argument)
	ret

_ftol2	endp

; MSC internal intrinsic _ftol2_sse():
; receives argument in FPU st(0), returns result in edx:eax

; NOTE: fisttp truncates, i.e. rounds towards 0!

_ftol2_sse proc	public

	push	edx
	push	eax
	fisttp	qword ptr [esp]		; [esp] = integer(argument)
	pop	eax
	pop	edx			; edx:eax = integer(argument)
	ret

_ftol2_sse endp
	end
<<NOKEEP

MSC_DEMO.INT: MSC_DEMO.MAK
	ML.EXE /Brepro /Cp /Cx /c /coff /DJCCLESS /Fo$@ /Gy /nologo /safeseh /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.686
	.model	flat, C
	.code

; https://msdn.microsoft.com/en-us/library/ms648425.aspx

; MSC internal _alldiv():
; receives arguments on stack, returns quotient in edx:eax

; NOTE: _alldiv() can raise 'division by zero' exception; it prevents
;       quotient overflow and does not raise 'integer overflow' exception,
;       but returns 2**63 for -2**63 / -1!

_alldiv	proc	public			; sqword _alldiv(sqword dividend, sqword divisor)

	push	ebx

	; determine sign of dividend and compute |dividend|

	mov	edx, [esp+12]		; edx = high dword of dividend
	mov	eax, [esp+8]		; eax = low dword of dividend

	mov	ebx, edx
	sar	ebx, 31			; ebx = (dividend < 0) ? -1 : 0
	xor	eax, ebx
	xor	edx, ebx		; edx:eax = (dividend < 0) ? ~dividend : dividend
	sub	eax, ebx
	sbb	edx, ebx		; edx:eax = (dividend < 0) ? -dividend : dividend
					;         = |dividend|

	mov	[esp+8], eax		; write |dividend| back on stack
	mov	[esp+12], edx

	; determine sign of divisor and compute |divisor|

	mov	edx, [esp+20]		; edx = high dword of divisor
	mov	eax, [esp+16]		; eax = low dword of divisor

	mov	ecx, edx
	sar	ecx, 31			; ecx = (divisor < 0) ? -1 : 0
	xor	eax, ecx
	xor	edx, ecx		; edx:eax = (divisor < 0) ? ~divisor : divisor
	sub	eax, ecx
	sbb	edx, ecx		; edx:eax = (divisor < 0) ? -divisor : divisor
					;         = |divisor|

	mov	[esp+16], eax		; write |divisor| back on stack
	mov	[esp+20], edx

	xor	ecx, ebx		; ecx = (dividend < 0) ^ (divisor < 0) ? -1 : 0
					;     = (quotient < 0) ? -1 : 0
	push	ecx			; [esp] = (quotient < 0) ? -1 : 0
ifdef TRIVIAL
	mov	ecx, [esp+16]		; ecx = high dword of dividend
	cmp	ecx, edx
	jb	short trivial		; (high dword of) dividend < (high dword of) divisor?
endif
	bsr	ecx, edx		; ecx = index of most significant '1' bit in high dword of divisor
	jnz	short extended		; high dword of divisor <> 0?

	; remainder < divisor < 2**32

	mov	ecx, eax		; ecx = (low dword of) divisor
	mov	eax, [esp+16]		; eax = high dword of dividend
	cmp	eax, ecx
	jae	short long		; high dword of dividend >= divisor?

	; perform normal division
normal:
	mov	edx, eax		; edx = high dword of dividend
	mov	eax, [esp+12]		; edx:eax = dividend
	div	ecx			; eax = (low dword of) quotient,
					; edx = (low dword of) remainder
;;	xor	edx, edx		; edx:eax = |quotient|

	pop	edx			; edx = (quotient < 0) ? -1 : 0
	xor	eax, edx
	sub	eax, edx
	sbb	edx, edx		; edx:eax = quotient

	pop	ebx
	ret	16			; callee restores stack

	; perform "long" alias "schoolbook" division
long:
;;	xor	edx, edx		; edx:eax = high dword of dividend
	div	ecx			; eax = high dword of quotient,
					; edx = high dword of remainder'
	mov	ebx, eax		; ebx = high dword of quotient
	mov	eax, [esp+12]		; eax = low dword of dividend
	div	ecx			; eax = low dword of quotient,
					; edx = (low dword of) remainder
	mov	edx, ebx		; edx:eax = |quotient|

	pop	ecx			; ecx = (quotient < 0) ? -1 : 0
	xor	eax, ecx
	xor	edx, ecx
	sub	eax, ecx
	sbb	edx, ecx		; edx:eax = quotient

	pop	ebx
	ret	16			; callee restores stack

	; dividend >= divisor >= 2**32: quotient < 2**32
	; perform "extended & adjusted" division
extended:
	push	edi

	not	ecx			; ecx = number of leading '0' bits in (high dword of) divisor
	shld	edx, eax, cl		; edx = divisor / 2**(index + 1)
					;     = divisor'
;;	shl	eax, cl
	mov	ebx, edx		; ebx = divisor'

	mov	eax, [esp+16]
	mov	edx, [esp+20]		; edx:eax = dividend
ifndef JCCLESS
	xor	edi, edi		; edi = high dword of quotient' = 0

	cmp	edx, ebx
	jb	short @f		; high dword of dividend < divisor'?

	; high dword of dividend >= divisor':
	; subtract divisor' from high dword of dividend to prevent possible
	; division overflow and set most significant bit of quotient"

	sub	edx, ebx		; edx = high dword of dividend - divisor'
					;     = high dword of dividend'
	inc	edi			; edi = high dword of quotient' = 1
@@:
else ; JCCLESS
	sub	edx, ebx		; edx = high dword of dividend - divisor'
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	and	edi, ebx		; edi = (high dword of dividend < divisor') ? divisor' : 0
	add	edx, edi		; edx = high dword of dividend
					;     - (high dword of dividend < divisor') ? 0 : divisor'
					;     = high dword of dividend'
	neg	edi			; CF = (high dword of dividend < divisor')
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	inc	edi			; edi = (high dword of dividend < divisor') ? 0 : 1
					;     = high dword of quotient'
endif ; JCCLESS
	; high dword of dividend' < divisor'

	div	ebx			; eax = dividend' / divisor'
					;     = low dword of quotient',
					; edx = remainder'
	shld	edi, eax, cl		; edi = quotient' / 2**(index + 1)
					;     = dividend / divisor'
					;     = quotient"
;;	shl	eax, cl

	mov	eax, [esp+24]		; eax = low dword of divisor
	mul	edi			; edx:eax = low dword of divisor * quotient"

	mov	ecx, [esp+16]
	mov	ebx, [esp+20]		; ebx:ecx = dividend
	sub	ecx, eax
	sbb	ebx, edx		; ebx:ecx = dividend - low dword of divisor * quotient"

	mov	eax, [esp+28]		; eax = high dword of divisor
	imul	eax, edi		; eax = high dword of divisor * quotient"

	sub	ebx, eax		; ebx:ecx = dividend - divisor * quotient"
					;         = remainder"
	sbb	eax, eax		; eax = (remainder" < 0) ? -1 : 0
	add	eax, edi		; eax = quotient" - (remainder" < 0)
					;     = (low dword of) |quotient|
;;	xor	edx, edx		; edx:eax = |quotient|

	pop	edi

	pop	edx			; edx = (quotient < 0) ? -1 : 0
	xor	eax, edx
	sub	eax, edx
	sbb	edx, edx		; edx:eax = quotient

	pop	ebx
	ret	16			; callee restores stack

_alldiv	endp

; MSC internal _alldvrm():
; receives arguments on stack, returns quotient in edx:eax and remainder in ebx:ecx

; NOTE: _alldvrm() can raise 'division by zero' exception; it prevents
;       quotient overflow and does not raise 'integer overflow' exception,
;       but returns 2**63 for -2**63 / -1!

_alldvrm proc	public			; sqword _alldvrm(sqword dividend, sqword divisor)

	push	edi

	; determine sign of dividend and compute |dividend|

	mov	edx, [esp+12]		; edx = high dword of dividend
	mov	eax, [esp+8]		; eax = low dword of dividend

	mov	edi, edx
	sar	edi, 31			; edi = (dividend < 0) ? -1 : 0
					;     = (remainder < 0) ? -1 : 0
	xor	eax, edi
	xor	edx, edi		; edx:eax = (dividend < 0) ? ~dividend : dividend
	sub	eax, edi
	sbb	edx, edi		; edx:eax = (dividend < 0) ? -dividend : dividend
					;         = |dividend|

	mov	[esp+8], eax		; write |dividend| back on stack
	mov	[esp+12], edx

	; determine sign of divisor and compute |divisor|

	mov	edx, [esp+20]		; edx = high dword of divisor
	mov	eax, [esp+16]		; eax = low dword of divisor

	mov	ecx, edx
	sar	ecx, 31			; ecx = (divisor < 0) ? -1 : 0
	xor	eax, ecx
	xor	edx, ecx		; edx:eax = (divisor < 0) ? ~divisor : divisor
	sub	eax, ecx
	sbb	edx, ecx		; edx:eax = (divisor < 0) ? -divisor : divisor
					;         = |divisor|

	mov	[esp+16], eax		; write |divisor| back on stack
	mov	[esp+20], edx

	xor	ecx, edi		; ecx = (divisor < 0) ^ (dividend < 0) ? -1 : 0
					;     = (quotient < 0) ? -1 : 0
	push	ecx			; [esp] = (quotient < 0) ? -1 : 0
ifdef TRIVIAL
	mov	ecx, [esp+16]		; ecx = high dword of dividend
	cmp	ecx, edx
	jb	short trivial		; (high dword of) dividend < (high dword of) divisor?
endif
	bsr	ecx, edx		; ecx = index of most significant '1' bit in high dword of divisor
	jnz	short extended		; high dword of divisor <> 0?

	; remainder < divisor < 2**32

	mov	ecx, eax		; ecx = (low dword of) divisor
	mov	eax, [esp+16]		; eax = high dword of dividend
	cmp	eax, ecx
	jae	short long		; high dword of dividend >= divisor?

	; perform normal division
normal:
	mov	edx, eax		; edx = high dword of dividend
	xor	ebx, ebx		; ebx = high dword of quotient = 0
	jmp	short next

	; perform "long" alias "schoolbook" division
long:
;;	xor	edx, edx		; edx:eax = high dword of dividend
	div	ecx			; eax = high dword of quotient,
					; edx = high dword of remainder'
	mov	ebx, eax		; ebx = high dword of quotient
next:
	mov	eax, [esp+12]		; eax = low dword of dividend
	div	ecx			; eax = low dword of quotient,
					; edx = (low dword of) remainder

	mov	ecx, edx		; ecx = (low dword of) |remainder|
	mov	edx, ebx		; edx:eax = |quotient|
;;	xor	ebx, ebx		; ebx:ecx = |remainder|

	pop	ebx			; ebx = (quotient < 0) ? -1 : 0
	xor	eax, ebx
	xor	edx, ebx
	sub	eax, ebx
	sbb	edx, ebx		; edx:eax = quotient

	mov	ebx, edi		; ebx = (remainder < 0) ? -1 : 0
	xor	ecx, ebx
	sub	ecx, ebx
	sbb	ebx, ebx		; ebx:ecx = remainder

	pop	edi
	ret	16			; callee restores stack

	; dividend >= divisor >= 2**32: quotient < 2**32
	; perform "extended & adjusted" division
extended:
	push	edi			; save sign of remainder

	not	ecx			; ecx = number of leading '0' bits in (high dword of) divisor
	shld	edx, eax, cl		; edx = divisor / 2**(index + 1)
					;     = divisor'
;;	shl	eax, cl
	mov	ebx, edx		; ebx = divisor'

	mov	eax, [esp+16]
	mov	edx, [esp+20]		; edx:eax = dividend
ifndef JCCLESS
	xor	edi, edi		; edi = high dword of quotient' = 0

	cmp	edx, ebx
	jb	short @f		; high dword of dividend < divisor'?

	; high dword of dividend >= divisor':
	; subtract divisor' from high dword of dividend to prevent possible
	; division overflow and set most significant bit of quotient"

	sub	edx, ebx		; edx = high dword of dividend - divisor'
					;     = high dword of dividend'
	inc	edi			; edi = high dword of quotient' = 1
@@:
else ; JCCLESS
	sub	edx, ebx		; edx = high dword of dividend - divisor'
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	and	edi, ebx		; edi = (high dword of dividend < divisor') ? divisor' : 0
	add	edx, edi		; edx = high dword of dividend
					;     - (high dword of dividend < divisor') ? 0 : divisor'
					;     = high dword of dividend'
	neg	edi			; CF = (high dword of dividend < divisor')
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	inc	edi			; edi = (high dword of dividend < divisor') ? 0 : 1
					;     = high dword of quotient'
endif ; JCCLESS
	; high dword of dividend' < divisor'

	div	ebx			; eax = dividend' / divisor'
					;     = low dword of quotient',
					; edx = remainder'
	shld	edi, eax, cl		; edi = quotient' / 2**(index + 1)
					;     = dividend / divisor'
					;     = quotient"
;;	shl	eax, cl

	mov	eax, [esp+24]		; eax = low dword of divisor
	mul	edi			; edx:eax = low dword of divisor * quotient"

	mov	ecx, [esp+16]
	mov	ebx, [esp+20]		; ebx:ecx = dividend
	sub	ecx, eax
	sbb	ebx, edx		; ebx:ecx = dividend - low dword of divisor * quotient"

	mov	eax, [esp+28]		; eax = high dword of divisor
	imul	eax, edi		; eax = high dword of divisor * quotient"

	sub	ebx, eax		; ebx:ecx = dividend - divisor * quotient"
					;         = remainder"
ifndef JCCLESS
	jnb	short @f		; remainder" >= 0?
					; with borrow, it is off by divisor,
					;  and quotient" is off by 1
if 0
	sbb	edi, 0			; edi = quotient" - 1
					;     = |quotient|
else
	dec	edi			; edi = quotient" - 1
					;     = |quotient|
endif
	add	ecx, [esp+24]
	adc	ebx, [esp+28]		; ebx:ecx = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = |remainder|
@@:
else ; JCCLESS
	sbb	eax, eax		; eax = (remainder" < 0) ? -1 : 0
	cdq				; edx = (remainder" < 0) ? -1 : 0
	add	edi, eax		; edi = quotient" - 1
					;     = |quotient|
	and	eax, [esp+24]
	and	edx, [esp+28]		; edx:eax = (remainder" < 0) ? divisor : 0
	add	ecx, eax
	adc	ebx, edx		; ebx:ecx = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = |remainder|
endif ; JCCLESS
	mov	eax, edi		; eax = (low dword of) |quotient|
;;	xor	edx, edx		; edx:eax = |quotient|

	pop	edi			; edi = (remainder < 0) ? -1 : 0

	pop	edx			; edx = (quotient < 0) ? -1 : 0
	xor	eax, edx
	sub	eax, edx
	sbb	edx, edx		; edx:eax = quotient

	xor	ecx, edi
	xor	ebx, edi
	sub	ecx, edi
	sbb	ebx, edi		; ebx:ecx = remainder

	pop	edi
	ret	16			; callee restores stack

_alldvrm endp

; MSC internal _allmul():
; receives arguments on stack, returns product modulo 2**64 in edx:eax

_allmul	proc	public			; sqword _allmul(sqword multiplicand, sqword multiplier)

	mov	eax, [esp+4]		; eax = low dword of multiplicand
	mov	edx, [esp+8]		; edx = high dword of multiplicand
	imul	edx, [esp+12]		; edx = high dword of multiplicand
					;     * low dword of multiplier
	mov	ecx, [esp+16]		; ecx = high dword of multiplier
	imul	ecx, eax		; ecx = high dword of multiplier
					;     * low dword of multiplicand
	add	ecx, edx		; ecx = high dword of multiplier
					;     * low dword of multiplicand
					;     + high dword of multiplicand
					;     * low dword of multiplier
	mul	dword ptr [esp+12]	; edx:eax = low dword of multiplicand
					;         * low dword of multiplier
	add	edx, ecx		; edx:eax = product % 2**64
	ret	16			; callee restores stack

_allmul	endp

; MSC internal _allrem():
; receives arguments on stack, returns remainder in edx:eax

; NOTE: _allrem() can raise 'division by zero' exception; it prevents
;       quotient overflow and does not raise 'integer overflow' exception!

_allrem	proc	public			; sqword _allrem(sqword dividend, sqword divisor)

	; determine sign of dividend and compute |dividend|

	mov	eax, [esp+8]		; eax = high dword of dividend
	mov	ecx, [esp+4]		; ecx = low dword of dividend

	cdq				; edx = (dividend < 0) ? -1 : 0
	xor	ecx, edx
	xor	eax, edx		; ecx:eax = (dividend < 0) ? ~dividend : dividend
	sub	ecx, edx
	sbb	eax, edx		; ecx:eax = (dividend < 0) ? -dividend : dividend
					;         = |dividend|

	mov	[esp+4], ecx		; write |dividend| back on stack
	mov	[esp+8], eax

	push	edx			; [esp] = (dividend < 0) ? -1 : 0

	; determine sign of divisor and compute |divisor|

	mov	edx, [esp+20]		; edx = high dword of divisor
	mov	eax, [esp+16]		; eax = low dword of divisor

	mov	ecx, edx
	sar	ecx, 31			; ecx = (divisor < 0) ? -1 : 0
	xor	eax, ecx
	xor	edx, ecx		; edx:eax = (divisor < 0) ? ~divisor : divisor
	sub	eax, ecx
	sbb	edx, ecx		; edx:eax = (divisor < 0) ? -divisor : divisor
					;         = |divisor|

	mov	[esp+16], eax		; write |divisor| back on stack
	mov	[esp+20], edx
ifdef TRIVIAL
	mov	ecx, [esp+12]		; ecx = high dword of dividend
	cmp	ecx, edx
	jb	short trivial		; (high dword of) dividend < (high dword of) divisor?
endif
	bsr	ecx, edx		; ecx = index of most significant '1' bit in high dword of divisor
	jnz	short extended		; high dword of divisor <> 0?

	; remainder < divisor < 2**32

	mov	ecx, eax		; ecx = (low dword of) divisor
	mov	eax, [esp+12]		; eax = high dword of dividend
	cmp	eax, ecx
	jae	short long		; high dword of dividend >= divisor?

	; perform normal division
normal:
	mov	edx, eax		; edx = high dword of dividend
	jmp	short next

	; perform "long" alias "schoolbook" division
long:
;;	xor	edx, edx		; edx:eax = high dword of dividend
	div	ecx			; eax = high dword of quotient,
					; edx = high dword of remainder'
next:
	mov	eax, [esp+8]		; eax = low dword of dividend
	div	ecx			; eax = low dword of quotient,
					; edx = (low dword of) remainder
	mov	eax, edx		; eax = (low dword of) |remainder|
;;	xor	edx, edx		; edx:eax = |remainder|

	pop	edx			; edx = (remainder < 0) ? -1 : 0
	xor	eax, edx
	sub	eax, edx
	sbb	edx, edx		; edx:eax = remainder

	ret	16			; callee restores stack

	; dividend >= divisor >= 2**32: quotient < 2**32
	; perform "extended & adjusted" division
extended:
	push	ebx
	push	edi

	not	ecx			; ecx = number of leading '0' bits in (high dword of) divisor
	shld	edx, eax, cl		; edx = divisor / 2**(index + 1)
					;     = divisor'
;;	shl	eax, cl
	mov	ebx, edx		; ebx = divisor'

	mov	eax, [esp+16]
	mov	edx, [esp+20]		; edx:eax = dividend
ifndef JCCLESS
	xor	edi, edi		; edi = high dword of quotient' = 0

	cmp	edx, ebx
	jb	short @f		; high dword of dividend < divisor'?

	; high dword of dividend >= divisor':
	; subtract divisor' from high dword of dividend to prevent possible
	; division overflow and set most significant bit of quotient"

	sub	edx, ebx		; edx = high dword of dividend - divisor'
					;     = high dword of dividend'
	inc	edi			; edi = high dword of quotient' = 1
@@:
else ; JCCLESS
	sub	edx, ebx		; edx = high dword of dividend - divisor'
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	and	edi, ebx		; edi = (high dword of dividend < divisor') ? divisor' : 0
	add	edx, edi		; edx = high dword of dividend
					;     - (high dword of dividend < divisor') ? 0 : divisor'
					;     = high dword of dividend'
	neg	edi			; CF = (high dword of dividend < divisor')
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	inc	edi			; edi = (high dword of dividend < divisor') ? 0 : 1
					;     = high dword of quotient'
endif ; JCCLESS
	; high dword of dividend' < divisor'

	div	ebx			; eax = dividend' / divisor'
					;     = low dword of quotient',
					; edx = remainder'
	shld	edi, eax, cl		; edi = quotient' / 2**(index + 1)
					;     = dividend / divisor'
					;     = quotient"
;;	shl	eax, cl

	mov	eax, [esp+24]		; eax = low dword of divisor
	mul	edi			; edx:eax = low dword of divisor * quotient"

	mov	ecx, [esp+16]
	mov	ebx, [esp+20]		; ebx:ecx = dividend
	sub	ecx, eax
	sbb	ebx, edx		; ebx:ecx = dividend - low dword of divisor * quotient"

	mov	eax, [esp+28]		; eax = high dword of divisor
	imul	eax, edi		; eax = high dword of divisor * quotient"

	sub	ebx, eax		; ebx:ecx = dividend - divisor * quotient"
					;         = remainder"
ifndef JCCLESS
	jnb	short @f		; remainder" >= 0?
					; with borrow, it is off by divisor
					;  (and quotient" is off by 1)
	add	ecx, [esp+24]
	adc	ebx, [esp+28]		; ebx:ecx = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = remainder
@@:
	mov	eax, ecx
	mov	edx, ebx		; edx:eax = |remainder|
else ; JCCLESS
	sbb	eax, eax		; eax = (remainder" < 0) ? -1 : 0
	cdq				; edx = (remainder" < 0) ? -1 : 0
	and	eax, [esp+24]
	and	edx, [esp+28]		; edx:eax = (remainder" < 0) ? divisor : 0
	add	eax, ecx
	adc	edx, ebx		; edx:eax = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = |remainder|
endif ; JCCLESS
	pop	edi
	pop	ebx

	pop	ecx			; ecx = (remainder < 0) ? -1 : 0
	xor	eax, ecx
	xor	edx, ecx
	sub	eax, ecx
	sbb	edx, ecx		; edx:eax = remainder

	ret	16			; callee restores stack

_allrem	endp

; MSC internal _allshl():
; receives arguments in edx:eax and cl, returns result in edx:eax

; NOTE: _allshl() applies shift count modulo 64

_allshl	proc	public			; sqword _allshl(sqword value, byte count)

	test	cl, 32
	jnz	short @f		; count > 31?

	shld	edx, eax, cl
	shl	eax, cl
	ret
@@:
	mov	edx, eax
	shl	edx, cl
	xor	eax, eax
	ret

_allshl	endp

; MSC internal _allshr():
; receives arguments in edx:eax and cl, returns result in edx:eax

; NOTE: _allshr() applies shift count modulo 64

_allshr	proc	public			; sqword _allshr(sqword value, byte count)

	test	cl, 32
	jnz	short @f		; count > 31?

	shrd	eax, edx, cl
	sar	edx, cl
	ret
@@:
	mov	eax, edx
	sar	eax, cl
	sar	edx, 31
	ret

_allshr	endp

; https://msdn.microsoft.com/en-us/library/mt703294.aspx

; MSC internal _aulldiv():
; receives arguments on stack, returns quotient in edx:eax

; NOTE: _aulldiv() can raise 'division by zero' exception!

_aulldiv proc	public			; qword _aulldiv(qword dividend, qword divisor)

	mov	edx, [esp+16]		; edx = high dword of divisor
ifdef TRIVIAL
	mov	eax, [esp+8]		; eax = high dword of dividend
	cmp	eax, edx
	jb	short trivial		; (high dword of) dividend < (high dword of) divisor?
endif
	bsr	ecx, edx		; ecx = index of most significant '1' bit in high dword of divisor
	jnz	short extended		; high dword of divisor <> 0?

	; remainder < divisor < 2**32

	mov	ecx, [esp+12]		; ecx = (low dword of) divisor
ifndef TRIVIAL
	mov	eax, [esp+8]		; eax = high dword of dividend
endif
	cmp	eax, ecx
	jae	short long		; high dword of dividend >= divisor?

	; perform normal division
normal:
	mov	edx, eax		; edx = high dword of dividend
	mov	eax, [esp+4]		; edx:eax = dividend
	div	ecx			; eax = (low dword of) quotient,
					; edx = (low dword of) remainder
	xor	edx, edx		; edx:eax = quotient

	ret	16			; callee restores stack

	; perform "long" alias "schoolbook" division
long:
;;	xor	edx, edx		; edx:eax = high dword of dividend
	div	ecx			; eax = high dword of quotient,
					; edx = high dword of remainder'
	push	eax			; [esp] = high dword of quotient
	mov	eax, [esp+8]		; eax = low dword of dividend
	div	ecx			; eax = low dword of quotient,
					; edx = (low dword of) remainder
	pop	edx			; edx:eax = quotient

	ret	16			; callee restores stack
ifdef TRIVIAL
	; dividend < divisor
trivial:
	xor	eax, eax
	xor	edx, edx		; edx:eax = quotient = 0

	ret	16			; callee restores stack
endif
	; dividend >= divisor >= 2**32: quotient < 2**32
	; perform "extended & adjusted" division
extended:
	push	ebx
	push	edi

	mov	eax, [esp+20]		; edx:eax = divisor
	not	ecx			; ecx = number of leading '0' bits in (high dword of) divisor
	shld	edx, eax, cl		; edx = divisor / 2**(index + 1)
					;     = divisor'
;;	shl	eax, cl
	mov	ebx, edx		; ebx = divisor'

	mov	eax, [esp+12]
	mov	edx, [esp+16]		; edx:eax = dividend
ifndef JCCLESS
	xor	edi, edi		; edi = high dword of quotient' = 0

	cmp	edx, ebx
	jb	short @f		; high dword of dividend < divisor'?

	; high dword of dividend >= divisor':
	; subtract divisor' from high dword of dividend to prevent possible
	; division overflow and set most significant bit of quotient"

	sub	edx, ebx		; edx = high dword of dividend - divisor'
					;     = high dword of dividend'
	inc	edi			; edi = high dword of quotient' = 1
@@:
else ; JCCLESS
	sub	edx, ebx		; edx = high dword of dividend - divisor'
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	and	edi, ebx		; edi = (high dword of dividend < divisor') ? divisor' : 0
	add	edx, edi		; edx = high dword of dividend
					;     - (high dword of dividend < divisor') ? 0 : divisor'
					;     = high dword of dividend'
	neg	edi			; CF = (high dword of dividend < divisor')
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	inc	edi			; edi = (high dword of dividend < divisor') ? 0 : 1
					;     = high dword of quotient'
endif ; JCCLESS
	; high dword of dividend' < divisor'

	div	ebx			; eax = dividend' / divisor'
					;     = low dword of quotient',
					; edx = remainder'
	shld	edi, eax, cl		; edi = quotient' / 2**(index + 1)
					;     = dividend / divisor'
					;     = quotient"
;;	shl	eax, cl

	mov	eax, [esp+20]		; eax = low dword of divisor
	mul	edi			; edx:eax = low dword of divisor * quotient"

	mov	ecx, [esp+12]
	mov	ebx, [esp+16]		; ebx:ecx = dividend
	sub	ecx, eax
	sbb	ebx, edx		; ebx:ecx = dividend - low dword of divisor * quotient"

	mov	eax, [esp+24]		; eax = high dword of divisor
	imul	eax, edi		; eax = high dword of divisor * quotient"
if 0
	sub	ebx, eax		; ebx:ecx = dividend - divisor * quotient"
					;         = remainder"
	sbb	eax, eax		; eax = (remainder" < 0) ? -1 : 0
	add	eax, edi		; eax = quotient" - (remainder" < 0)
					;     = (low dword of) quotient
	xor	edx, edx		; edx:eax = quotient
else
	xor	edx, edx		; edx = high dword of quotient = 0
	sub	ebx, eax		; ebx:ecx = dividend - divisor * quotient"
					;         = remainder"
	mov	eax, edi		; eax = quotient"
	sbb	eax, edx		; eax = quotient" - (remainder" < 0)
					;     = (low dword of) quotient
endif
	pop	edi
	pop	ebx
	ret	16			; callee restores stack

_aulldiv endp

; MSC internal _aulldvrm():
; receives arguments on stack, returns quotient in edx:eax and remainder in ebx:ecx

; NOTE: _aulldvrm() can raise 'division by zero' exception!

_aulldvrm proc	public			; qword _aulldvrm(qword dividend, qword divisor)

	mov	edx, [esp+16]		; edx = high dword of divisor
ifdef TRIVIAL
	mov	eax, [esp+8]		; eax = high dword of dividend
	cmp	eax, edx
	jb	short trivial		; (high dword of) dividend < (high dword of) divisor?
endif
	bsr	ecx, edx		; ecx = index of most significant '1' bit in high dword of divisor
	jnz	short extended		; high dword of divisor <> 0?

	; remainder < divisor < 2**32

	mov	ecx, [esp+12]		; ecx = (low dword of) divisor
ifndef TRIVIAL
	mov	eax, [esp+8]		; eax = high dword of dividend
endif
	cmp	eax, ecx
	jae	short long		; high dword of dividend >= divisor?

	; perform normal division
normal:
	mov	edx, eax		; edx = high dword of dividend
	mov	eax, [esp+4]		; edx:eax = dividend
	div	ecx			; eax = (low dword of) quotient,
					; edx = (low dword of) remainder
	mov	ecx, edx		; ecx = (low dword of) remainder
	xor	ebx, ebx		; ebx:ecx = remainder
	xor	edx, edx		; edx:eax = quotient

	ret	16			; callee restores stack

	; perform "long" alias "schoolbook" division
long:
;;	xor	edx, edx		; edx:eax = high dword of dividend
	div	ecx			; eax = high dword of quotient,
					; edx = high dword of remainder'
	mov	ebx, eax		; ebx = high dword of quotient
	mov	eax, [esp+4]		; eax = low dword of dividend
	div	ecx			; eax = low dword of quotient,
					; edx = (low dword of) remainder
if 1
	mov	ecx, edx		; ecx = (low dword of) remainder
	mov	edx, ebx		; edx:eax = quotient
	xor	ebx, ebx		; ebx:ecx = remainder
else
	xor	ecx, ecx
	xchg	edx, ebx		; edx:eax = quotient
	xchg	ebx, ecx		; ebx:ecx = remainder
endif
	ret	16			; callee restores stack
ifdef TRIVIAL
	; dividend < divisor
trivial:
	mov	ecx, [esp+4]		; ecx = low dword of dividend
	mov	ebx, eax		; ebx:ecx = remainder = dividend
	xor	eax, eax
	xor	edx, edx		; edx:eax = quotient = 0

	ret	16			; callee restores stack
endif
	; dividend >= divisor >= 2**32: quotient < 2**32
	; perform "extended & adjusted" division
extended:
	push	edi

	mov	eax, [esp+16]		; edx:eax = divisor
	not	ecx			; ecx = number of leading '0' bits in (high dword of) divisor
	shld	edx, eax, cl		; edx = divisor / 2**(index + 1)
					;     = divisor'
;;	shl	eax, cl
	mov	ebx, edx		; ebx = divisor'

	mov	eax, [esp+8]
	mov	edx, [esp+12]		; edx:eax = dividend
ifndef JCCLESS
	xor	edi, edi		; edi = high dword of quotient' = 0

	cmp	edx, ebx
	jb	short @f		; high dword of dividend < divisor'?

	; high dword of dividend >= divisor':
	; subtract divisor' from high dword of dividend to prevent possible
	; division overflow and set most significant bit of quotient"

	sub	edx, ebx		; edx = high dword of dividend - divisor'
					;     = high dword of dividend'
	inc	edi			; edi = high dword of quotient' = 1
@@:
else ; JCCLESS
	sub	edx, ebx		; edx = high dword of dividend - divisor'
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	and	edi, ebx		; edi = (high dword of dividend < divisor') ? divisor' : 0
	add	edx, edi		; edx = high dword of dividend
					;     - (high dword of dividend < divisor') ? 0 : divisor'
					;     = high dword of dividend'
	neg	edi			; CF = (high dword of dividend < divisor')
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	inc	edi			; edi = (high dword of dividend < divisor') ? 0 : 1
					;     = high dword of quotient'
endif ; JCCLESS
	; high dword of dividend' < divisor'

	div	ebx			; eax = dividend' / divisor'
					;     = low dword of quotient',
					; edx = remainder'
	shld	edi, eax, cl		; edi = quotient' / 2**(index + 1)
					;     = dividend / divisor'
					;     = quotient"
;;	shl	eax, cl

	mov	eax, [esp+16]		; eax = low dword of divisor
	mul	edi			; edx:eax = low dword of divisor * quotient"

	mov	ecx, [esp+8]
	mov	ebx, [esp+12]		; ebx:ecx = dividend
	sub	ecx, eax
	sbb	ebx, edx		; ebx:ecx = dividend - low dword of divisor * quotient"

	mov	eax, [esp+20]		; eax = high dword of divisor
	imul	eax, edi		; eax = high dword of divisor * quotient"

	sub	ebx, eax		; ebx:ecx = dividend - divisor * quotient"
					;         = remainder"
ifndef JCCLESS
	jnb	short @f		; remainder" >= 0?
					; with borrow, it is off by divisor,
					;  and quotient" is off by 1
if 0
	sbb	edi, 0			; edi = quotient" - 1
					;     = quotient
else
	dec	edi			; edi = quotient" - 1
					;     = quotient
endif
	add	ecx, [esp+16]
	adc	ebx, [esp+20]		; ebx:ecx = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = remainder
@@:
else ; JCCLESS
	sbb	eax, eax		; eax = (remainder" < 0) ? -1 : 0
	cdq				; edx = (remainder" < 0) ? -1 : 0
	add	edi, eax		; edi = quotient" - 1
					;     = quotient
	and	eax, [esp+16]
	and	edx, [esp+20]		; edx:eax = (remainder" < 0) ? divisor : 0
	add	ecx, eax
	adc	ebx, edx		; ebx:ecx = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = remainder
endif ; JCCLESS
	mov	eax, edi		; eax = (low dword of) quotient
	xor	edx, edx		; edx:eax = quotient

	pop	edi
	ret	16			; callee restores stack

_aulldvrm endp

; MSC internal _aullrem():
; receives arguments on stack, returns remainder in edx:eax

; NOTE: _aullrem() can raise 'division by zero' exception!

_aullrem proc	public			; qword _aullrem(qword dividend, qword divisor)

	mov	edx, [esp+16]		; edx = high dword of divisor
ifdef TRIVIAL
	mov	eax, [esp+8]		; eax = high dword of dividend
	cmp	eax, edx
	jb	short trivial		; (high dword of) dividend < (high dword of) divisor?
endif
	bsr	ecx, edx		; ecx = index of most significant '1' bit in high dword of divisor
	jnz	short extended		; high dword of divisor <> 0?

	; remainder < divisor < 2**32

	mov	ecx, [esp+12]		; ecx = (low dword of) divisor
ifndef TRIVIAL
	mov	eax, [esp+8]		; eax = high dword of dividend
endif
	cmp	eax, ecx
	jae	short long		; high dword of dividend >= divisor?

	; perform normal division
normal:
	mov	edx, eax		; edx = high dword of dividend
	mov	eax, [esp+4]		; edx:eax = dividend
	div	ecx			; eax = (low dword of) quotient,
					; edx = (low dword of) remainder
	mov	eax, edx		; eax = (low dword of) remainder
	xor	edx, edx		; edx:eax = remainder

	ret	16			; callee restores stack

	; perform "long" alias "schoolbook" division
long:
;;	xor	edx, edx		; edx:eax = high dword of dividend
	div	ecx			; eax = high dword of quotient,
					; edx = high dword of remainder'
	mov	eax, [esp+4]		; eax = low dword of dividend
	div	ecx			; eax = low dword of quotient,
					; edx = (low dword of) remainder
	mov	eax, edx		; eax = (low dword of) remainder
	xor	edx, edx		; edx:eax = remainder

	ret	16			; callee restores stack
ifdef TRIVIAL
	; dividend < divisor
trivial:
	mov	edx, eax
	mov	eax, [esp+4]		; edx:eax = remainder = dividend

	ret	16			; callee restores stack
endif
	; dividend >= divisor >= 2**32: quotient < 2**32
	; perform "extended & adjusted" division
extended:
	push	ebx
	push	edi

	mov	eax, [esp+20]		; edx:eax = divisor
	not	ecx			; ecx = number of leading '0' bits in (high dword of) divisor
	shld	edx, eax, cl		; edx = divisor / 2**(index + 1)
					;     = divisor'
;;	shl	eax, cl
	mov	ebx, edx		; ebx = divisor'

	mov	eax, [esp+12]
	mov	edx, [esp+16]		; edx:eax = dividend
ifndef JCCLESS
	xor	edi, edi		; edi = high dword of quotient' = 0

	cmp	edx, ebx
	jb	short @f		; high dword of dividend < divisor'?

	; high dword of dividend >= divisor':
	; subtract divisor' from high dword of dividend to prevent possible
	; division overflow and set most significant bit of quotient"

	sub	edx, ebx		; edx = high dword of dividend - divisor'
					;     = high dword of dividend'
	inc	edi			; edi = high dword of quotient' = 1
@@:
else ; JCCLESS
	sub	edx, ebx		; edx = high dword of dividend - divisor'
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	and	edi, ebx		; edi = (high dword of dividend < divisor') ? divisor' : 0
	add	edx, edi		; edx = high dword of dividend
					;     - (high dword of dividend < divisor') ? 0 : divisor'
					;     = high dword of dividend'
	neg	edi			; CF = (high dword of dividend < divisor')
	sbb	edi, edi		; edi = (high dword of dividend < divisor') ? -1 : 0
	inc	edi			; edi = (high dword of dividend < divisor') ? 0 : 1
					;     = high dword of quotient'
endif ; JCCLESS
	; high dword of dividend' < divisor'

	div	ebx			; eax = dividend' / divisor'
					;     = low dword of quotient',
					; edx = remainder'
	shld	edi, eax, cl		; edi = quotient' / 2**(index + 1)
					;     = dividend / divisor'
					;     = quotient"
;;	shl	eax, cl

	mov	eax, [esp+20]		; eax = low dword of divisor
	mul	edi			; edx:eax = low dword of divisor * quotient"

	mov	ecx, [esp+12]
	mov	ebx, [esp+16]		; ebx:ecx = dividend
	sub	ecx, eax
	sbb	ebx, edx		; ebx:ecx = dividend - low dword of divisor * quotient"

	mov	eax, [esp+24]		; eax = high dword of divisor
	imul	eax, edi		; eax = high dword of divisor * quotient"

	sub	ebx, eax		; ebx:ecx = dividend - divisor * quotient"
					;         = remainder"
ifndef JCCLESS
	jnb	short @f		; remainder" >= 0?
					; with borrow, it is off by divisor
					;  (and quotient" is off by 1)
	add	ecx, [esp+20]
	adc	ebx, [esp+24]		; ebx:ecx = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = remainder
@@:
	mov	eax, ecx
	mov	edx, ebx		; edx:eax = remainder
else ; JCCLESS
	sbb	eax, eax		; eax = (remainder" < 0) ? -1 : 0
	cdq				; edx = (remainder" < 0) ? -1 : 0
	and	eax, [esp+20]
	and	edx, [esp+24]		; edx:eax = (remainder" < 0) ? divisor : 0
	add	eax, ecx
	adc	edx, ebx		; edx:eax = remainder" + divisor
					;         = dividend - divisor * (quotient" - 1)
					;         = dividend - divisor * quotient
					;         = remainder
endif ; JCCLESS
	pop	edi
	pop	ebx
	ret	16			; callee restores stack

_aullrem endp

; MSC internal _aullshr():
; receives arguments in edx:eax and cl, returns result in edx:eax

; NOTE: _aullshr() applies shift count modulo 64

_aullshr proc	public			; qword _aullshr(qword value, byte count)

	test	cl, 32
	jnz	short @f		; count > 31?

	shrd	eax, edx, cl
	shr	edx, cl
	ret
@@:
	mov	eax, edx
	shr	eax, cl
	xor	edx, edx
	ret

_aullshr endp
	end
<<NOKEEP

MSC_DEMO.386: MSC_DEMO.MAK
	ML.EXE /Brepro /Cp /Cx /c /coff /Fo$@ /Gy /nologo /safeseh /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.686
	.model	flat, C

; https://msdn.microsoft.com/en-us/library/dn449700.aspx

_nt_tib	struct	4			; thread information block
chain	dword	?			; address of first exception registration record
base	dword	?			; stack base
limit	dword	?			; stack limit
	dword	?			; address of subsystem thread information block
fiber	dword	?			; fiber data
pointer	dword	?			; arbitrary user pointer
self	dword	?			; address of _nt_tib
_nt_tib	ends

	.code

; https://msdn.microsoft.com/en-us/library/wb1s57t5.aspx
; https://msdn.microsoft.com/en-us/library/ms648426.aspx

; MSC internal intrinsic _alloca() alias _chkstk():
; receives argument in eax, returns result in esp

; NOTE: _alloca() must preserve ALL argument registers;
;       it can raise 'stack overflow' exception!

;;	alias	<_chkstk> = <_alloca_probe_16>

_alloca_probe_16 proc	public		; void _alloca_probe_16(dword size)
_chkstk	proc	public			; void _chkstk(dword size)

	push	ebx			; decrement stack pointer, save register
	lea	ebx, [esp+8]		; ebx = stack pointer of caller
	sub	ebx, eax		; ebx = new (unaligned) stack pointer
if 0
	sbb	eax, eax		; eax = (ebx < 0) ? -1 : 0
	not	eax			; eax = (ebx < 0) ? 0 : -1
else
	cmc				; CF = ~(ebx < 0)
	sbb	eax, eax		; eax = (ebx < 0) ? 0 : -1
endif
	shl	eax, 4			; eax = (ebx < 0) ? 0 : -16
	and	eax, ebx		; eax = (ebx < 0) ? 0 : new (aligned) stack pointer

	assume	fs :flat
	mov	ebx, fs:[_nt_tib.limit]	; ebx = (current) stack limit
	cmp	ebx, eax
	jna	short done		; stack limit not above new stack pointer?
probe:
	sub	ebx, 4096		; ebx = next stack page
	test	ebx, [ebx]		; probe next stack page, eventually raise
					; 'guard page' or 'stack overflow' exception
	cmp	ebx, eax
	ja	short probe		; stack limit above new stack pointer?
done:
	pop	ebx			; restore register
	xchg	eax, esp		; esp = new stack pointer,
					; eax = old stack pointer
					;     = address of return address
	push	[eax]			; decrement stack pointer, write return address
	ret

_chkstk	endp
_alloca_probe_16 endp
	end
<<NOKEEP

MSC_DEMO.AMD: MSC_DEMO.MAK
	ML64.EXE /Brepro /Cp /Cx /c /Fo$@ /Gy /nologo /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

; https://msdn.microsoft.com/en-us/library/dn449700.aspx

_nt_tib	struct	8			; thread information block
chain	qword	?			; address of first exception registration record
base	qword	?			; stack base
limit	qword	?			; stack limit
	qword	?			; address of subsystem thread information block
fiber	qword	?			; fiber data
pointer	qword	?			; arbitrary user pointer
self	qword	?			; address of _nt_tib
_nt_tib	ends

	.code

; https://msdn.microsoft.com/en-us/library/wb1s57t5.aspx
; https://msdn.microsoft.com/en-us/library/ms648426.aspx
; https://msdn.microsoft.com/en-us/library/tawsa7cb.aspx

; MSC internal intrinsic _alloca() alias __chkstk():
; receives argument in rax

; NOTE: _alloca() must preserve RAX and ALL argument registers;
;       it can raise 'stack overflow' exception!

__chkstk proc	public			; qword __chkstk(qword size)

	xor	r10, r10		; r10 = 0
	lea	r11, [rsp+8]		; r11 = stack pointer of caller
	sub	r11, rax		; r11 = new stack pointer
	cmovb	r11, r10		; r11 = (r11 < 0) ? 0 : r11
;;	and	r11, -16		; r11 = new (aligned) stack pointer
;;	assume	gs :flat
	mov	r10, gs:[_nt_tib.limit]	; r10 = (current) stack limit
	cmp	r10, r11
	jna	short exit		; stack limit not above new stack pointer?
probe:
	lea	r10, [r10-4096]		; r10 = next stack page
	test	r10, [r10]		; probe next stack page, eventually raise
					; 'guard page' or 'stack overflow' exception
	cmp	r10, r11
	ja	short probe		; stack limit above new stack pointer?
exit:
	ret

__chkstk endp
	end
<<NOKEEP

MSC_DEMO.X64: MSC_DEMO.MAK
	ML64.EXE /Brepro /Cp /Cx /c /Fo$@ /Gy /nologo /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

; https://msdn.microsoft.com/en-us/library/ms680328.aspx

_lcu_64	struct	8
	dword	sizeof _lcu_64
	dword	"DEMO"
	word	0, 815
	dword	0, 0, 0
	qword	0, 0, 0, 0, 0, 0
	dword	0
	word	0, 2048			; LOAD_LIBRARY_SEARCH_SYSTEM32
	qword	0
	qword	offset __security_cookie
	qword	0, 0, 0, 0, 0, 0
	dword	0
_lcu_64	ends

	.const

	public	_load_config_used
_load_config_used \
	_lcu_64	<>

	.data

	public	__security_cookie
__security_cookie \
	qword	3141592653589793238 shr 16

	.code

; https://msdn.microsoft.com/en-us/library/8dbf701c.aspx
; https://msdn.microsoft.com/en-us/library/aa290051.aspx

__security_check_cookie \
	proc	public			; void __security_check_cookie(qword cookie)

	cmp	rcx, __security_cookie
	jne	short fastfail

;;	shr	rcx, 48
;;	jnz	short fastfail

	ret

; https://msdn.microsoft.com/en-us/library/dn774154.aspx

fastfail:
	mov	ecx, 2			; rcx = FAST_FAIL_STACK_COOKIE_CHECK_FAILURE
	int	41
	ud2

__security_check_cookie \
	endp

; https://msdn.microsoft.com/en-us/library/ms235362.aspx

__security_init_cookie \
	proc	public			; void __security_init_cookie(void)

	mov	rax, __security_cookie
	mov	rcx, 3141592653589793238 shr 16
	cmp	rcx, rax
	je	short init

	test	rax, rax
	jne	short exit
init:
	rdtsc				; rax = low dword of time stamp counter,
					; rdx = high dword of time stamp counter
	mov	ecx, edx		; rcx = high dword of time stamp counter
	bswap	edx
	imul	rcx, rax		; rcx = high dword of time stamp counter
					;     * low dword of time stamp counter
	bswap	rax
	xor	rax, rdx		; rax = byte-swapped time stamp counter
	mul	rcx
	xor	rax, rdx		; rax = random number
	shr	rax, 16
	mov	__security_cookie, rax
exit:
	ret

__security_init_cookie \
	endp
	end
<<NOKEEP

MSC_DEMO.AAA: MSC_DEMO.MAK
	ML64.EXE /Brepro /Cp /Cx /c /Fo$@ /Gy /nologo /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

; https://msdn.microsoft.com/en-us/library/6yh4a9k1.aspx
; https://msdn.microsoft.com/en-us/library/gg463119.aspx
; https://msdn.microsoft.com/en-us/library/ms680547.aspx

_tls_64	struct	8
	qword	offset _tls_start
	qword	offset _tls_end
	qword	offset _tls_index
	qword	0			; no callback functions!
	dword	'VOID'			; BUG: the module loader discards the 'SizeOfZeroFill' member!
	dword	0
_tls_64	ends

; https://msdn.microsoft.com/en-us/library/sf9b18xk.aspx

_tls_info segment alias(".drectve") discard info read
	byte	"/SECTION:.tls,!w"
_tls_info ends

_tls_data segment alias(".data$$T") dword read write
	public	_tls_index
_tls_index dword 'VOID'			; assigned by the module loader!
_tls_data ends

_tls_rdata segment alias(".rdata$$T") para read
	public	_tls_used
_tls_used _tls_64 <>			; IMAGE_TLS_DIRECTORY64
_tls_rdata ends

_tls_first segment alias(".tls") para read write
_tls_start equ $$
_tls_first ends

_tls_last segment alias(".tls$$~~~") byte read write
_tls_end equ $$
_tls_last ends
	end
<<NOKEEP

MSC_DEMO.III: MSC_DEMO.MAK
	ML.EXE /Brepro /Cp /Cx /c /Fo$@ /Gy /nologo /safeseh /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	flat, C

; https://msdn.microsoft.com/en-us/library/6yh4a9k1.aspx
; https://msdn.microsoft.com/en-us/library/gg463119.aspx
; https://msdn.microsoft.com/en-us/library/ms680547.aspx

	public	_tls_array
_tls_array equ	44			; offset of 'ThreadLocalStoragePointer' member in TEB;
					;  symbol referenced in code generated by the compiler!
_tls_32	struct	4
	dword	offset _tls_start
	dword	offset _tls_end
	dword	offset _tls_index
	dword	0			; no callback functions!
	dword	'VOID'			; BUG: the module loader discards the 'SizeOfZeroFill' member!
	dword	0
_tls_32	ends

; https://msdn.microsoft.com/en-us/library/sf9b18xk.aspx

_tls_info segment alias(".drectve") discard info read
	byte	"/SECTION:.tls,!w"
_tls_info ends

_tls_data segment alias(".data$$T") dword read write
	public	_tls_index
_tls_index dword 'VOID'			; assigned by the module loader!
_tls_data ends

_tls_rdata segment alias(".rdata$$T") dword read
	public	_tls_used
_tls_used _tls_32 <>			; IMAGE_TLS_DIRECTORY32
_tls_rdata ends

_tls_start segment alias(".tls") para read write
_tls_start ends

_tls_end segment alias(".tls$$~~~") byte read write
_tls_end ends
	end
<<NOKEEP

MSC_DEMO.OMF: MSC_DEMO.MAK
	ML.EXE /Brepro /Fo$@ /nologo /omf /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	tiny

; https://support.microsoft.com/en-us/kb/65122

e_header struct				; DOS .EXE header
e_magic	word	5A4Dh			; magic number "MZ"
e_cblp	word	stop - header		; bytes on last page of file
e_cp	word	1			; pages in file
e_crlc	word	0			; number of relocation table entries
e_cparhdr word	sizeof header / 16	; size of header in paragraphs
e_minalloc word	0			; minimum extra paragraphs needed
e_maxalloc word	65535			; maximum extra paragraphs needed
e_ss	word	0			; initial (PSP relative) SS value
e_sp	word	stack - header		; initial (SS relative) SP value
e_csum	word	0			; checksum
e_ip	word	sizeof message		; initial (CS relative) IP value
e_cs	word	0			; initial (PSP relative) CS value
e_lfarlc word	sizeof header		; file address of relocation table
e_ovno	word	0			; overlay number
e_res	word	4 dup (0)		; reserved words
e_oemid	word	5719h			; OEM identifier
e_oeminfo word	2704h			; OEM information
e_res2	word	10 dup (0)		; reserved words
e_lfanew dword	0			; file address of new exe header
e_header ends

	.code

header	e_header <>

message	byte	"(C)opyright 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>", 0Dh, 0Ah, 07h, 24h

start:
	push	cs
	pop	ds
	xor	dx, dx
	mov	ah, 09h
	int	21h

	mov	ax, 4C01h
	int	21h
stop:
	dword	20 dup (?)
stack:
	end	start
<<NOKEEP

MSC_DEMO.DOS: MSC_DEMO.MAK
#	IMAGE_DOS_HEADER stub =
#	{					// DOS .EXE header
#		0x5A4D,				// magic number "MZ"
#		0x0090,				// bytes on last page of file
#		0x0001,				// pages in file
#		0x0000,				// number of relocation table entries
#		0x0004,				// size of header in paragraphs
#		0x0000,				// minimum extra paragraphs needed
#		0xFFFF,				// maximum extra paragraphs needed
#		0x0000,				// initial (PSP relative) SS value
#		0x00E0,				// initial (SS relative) SP value
#		0x0000,				// checksum
#		0x0043,				// initial (CS relative) IP value
#		0x0000,				// initial (PSP relative) CS value
#		0x0040,				// file address of relocation table
#		0x0000,				// overlay number
#		{0, 0, 0, 0},			// reserved words
#		0x5719,				// OEM identifier
#		0x2704,				// OEM information
#		{0, 0, 0, 0, 0, 0, 0, 0, 0, 0},	// reserved words
#		0UL				// file address of new exe header
#	};
	CERTUTIL.EXE /DecodeHex /F /V << $@
4D 5A 90 00 01 00 00 00 04 00 00 00 FF FF 00 00   MZ..............
E0 00 00 00 43 00 00 00 40 00 00 00 00 00 00 00   ....C...@.......
00 00 00 00 19 57 04 27 00 00 00 00 00 00 00 00   .....W.'........
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ................
28 43 29 6F 70 79 72 69 67 68 74 20 32 30 30 34   (C)opyright 2004
2D 32 30 32 35 2C 20 53 74 65 66 61 6E 20 4B 61   -2025, Stefan Ka
6E 74 68 61 6B 20 3C 73 74 65 66 61 6E 2E 6B 61   nthak <stefan.ka
6E 74 68 61 6B 40 6E 65 78 67 6F 2E 64 65 3E 0D   nthak@nexgo.de>.
0A 07 24 0E 1F 33 D2 B4 09 CD 21 B8 01 4C CD 21   .....3....!..L.!
<<NOKEEP
